<g:Document Name="CabezalNewsClient.tpl" xmlns:g="urn:groove.net">

	<g:ComponentSecurity>
		<g:FingerprintTable>
			<g:Entry Fingerprint="4262-dcb1:4552-d303:123d-36a6:0a96-62e5:24a7-d7db" FingerprintID="Groove"/>
			<g:Entry Fingerprint="952d-9212:4839-e04b:8c4c-f1ae:60e0-12d1:8ced-49c5" FingerprintID="com.cabezal"/>
		</g:FingerprintTable>
	</g:ComponentSecurity>

	<g:ToolTemplate DefaultToolDisplayName="NewsClient" Name="NewsClient.Tool" TemplateDisplayName="NewsClient">
		<g:ViewInfo Lifetime="Limited"/>

		<g:ComponentGroup DefaultView="OuterViewContainer" Delegate="NewsClientGlue" DataModelDelegate="NewsClientDataGlue">

			<g:Schemas>
				<g:Schema URL="grooveDocument:///GrooveXSS/$PersistRoot/Schemas.xss/CabezalNewsClientSchema.xml"/>
			</g:Schemas>

<!--
			<g:SupportedTypes>
				<g:SupportedType Name="urn:groove.net:Core.RecordSetEngine"/>
				<g:SupportedType Name="urn:groove.net:Core.ToolCollections"/>
			</g:SupportedTypes>
-->

			<g:ObjectTypes>
				<g:ObjectType Name="$ComponentGroup">
					<g:AccessControl>
						<g:Roles>
							<g:Role Name="$ComponentGroup.CreateChannels" DisplayName="Create Channels" Category="Permission" Visible="true" DefaultParentRoles="$Telespace.Manager">
								<g:Operations>
									<g:Operation Name="AddRecord" TargetName="ChannelListRecordSetEngine"/>
									<g:Operation Name="ReplaceRecord" TargetName="ChannelListRecordSetEngine"/>
									<g:Operation Name="SetField" TargetName="urn:cabezal.com:NewsClientChannelRecord"/>
								</g:Operations>
							</g:Role>
							<g:Role Name="$ComponentGroup.DeleteChannels" DisplayName="Delete Channels" Category="Permission" Visible="true" DefaultParentRoles="$Telespace.Manager">
								<g:Operations>
									<g:Operation Name="RemoveRecord" TargetName="ChannelListRecordSetEngine"/>
									<g:Operation Name="ReplaceRecord" TargetName="ChannelListRecordSetEngine"/>
									<g:Operation Name="SetField" TargetName="urn:cabezal.com:NewsClientChannelRecord"/>
								</g:Operations>
							</g:Role>
							<g:Role Name="$ComponentGroup.SetChannelStatus" DisplayName="Set Channel Status" Category="Permission" Visible="true" DefaultParentRoles="$Telespace.Member $Telespace.Manager">
								<g:Operations>
									<g:Operation Name="ReplaceRecord" TargetName="ChannelListRecordSetEngine"/>
									<g:Operation Name="SetField" TargetName="urn:cabezal.com:NewsClientChannelRecord"/>
								</g:Operations>
							</g:Role>
						</g:Roles>
					</g:AccessControl>
				</g:ObjectType>
			</g:ObjectTypes>

<!--
	The main UI
-->
			<g:Component Name="OuterViewContainer">
				<g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=ViewContainer"/>
				<g:ComponentConnections>
					<g:Connection Name="OuterLayoutWithTabs" ConnectionID="0"/>
				</g:ComponentConnections>
				<g:PropertyList/>
			</g:Component>

            <g:Component Name="OuterLayoutWithTabs">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=MultiCellLayout"/>
                <g:PropertyList Version="1">
                    <g:Property Name="Layout">
                        <g:PropertyValue>
                            <MULTIROW>
                                <BORDER TopPad="3" RightPad="5" LeftPad="5"/>
                                <ROW>
                                    <CELL NAME="TabContents">
                                        NewsClientContainer
                                    </CELL>
                                </ROW>
                                <ROW>
                                    <CELL HEIGHT="25">
                                        Tabs
                                    </CELL>
                                </ROW>
                            </MULTIROW>
                        </g:PropertyValue>
                    </g:Property>
                </g:PropertyList>
            </g:Component>

            <g:Component Name="OuterLayoutWithoutTabs">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=MultiCellLayout"/>
                <g:PropertyList Version="1">
                    <g:Property Name="Layout">
                        <g:PropertyValue>
                            <MULTIROW>
                                <BORDER TopPad="3" RightPad="5" LeftPad="5"/>
                                <ROW>
                                    <CELL NAME="TabContents">
                                        NewsClientContainer
                                    </CELL>
                                </ROW>
                            </MULTIROW>
                        </g:PropertyValue>
                    </g:Property>
                </g:PropertyList>
            </g:Component>

            <g:Component Name="NewsClientContainer">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=ViewContainer"/>
                <g:PropertyList Version="1">
                    <g:Property Name="Background">
                        <g:BackgroundStyle Style="SectionBackground"/>
                    </g:Property>
                </g:PropertyList>
                <g:ComponentConnections>
                    <g:Connection Name="NewsClientHTMLLayout" ConnectionID="0"/>
                </g:ComponentConnections>
            </g:Component>

            <g:Component Name="NewsClientHTMLLayout">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=HTMLTableLayout"/>
                <g:PropertyList Version="1">
                    <g:Property Name="Layout">
                        <g:PropertyValue>
                            <TABLE CELLPADDING="2">
                                <TR>
                                    <TD>
						NewsClientSplitter
					</TD>
                                </TR>
				</TABLE>
                        </g:PropertyValue>
                    </g:Property>
                </g:PropertyList>
            </g:Component>


            <g:Component Name="NewsClientSplitter">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Splitter"/>
                <g:PropertyList Version="1">
                    <g:Property Name="Orientation" Value="Horizontal"/>
                    <g:Property Name="DefaultFocus" Value="View1"/>
                    <g:Property Name="Size" Value="Small"/>
                    <g:Property Name="Layout">
                        <g:PropertyValue>
                            <PANE1>
                                View1
                            </PANE1>
                            <PANE2 Size="50%">
                                View2
                            </PANE2>
                        </g:PropertyValue>
                    </g:Property>
                </g:PropertyList>
            </g:Component>

            <g:Component Name="View1">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=ViewContainer"/>
                <g:PropertyList Version="1"/>
                <g:ComponentConnections>
                    <g:Connection Name="View1Layout" ConnectionID="0"/>
                </g:ComponentConnections>
            </g:Component>

            <g:Component Name="View1Layout">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=HTMLTableLayout"/>
                <g:PropertyList Version="1">
                    <g:Property Name="Layout">
                        <g:PropertyValue>
                            <TABLE CELLPADDING="2">
                                <TR>
                                    <TD WIDTH="90" HEIGHT="20">
                                        ViewerSelectHeadlinesButton
                                    </TD>
                                    <TD NAME="Viewer" ROWSPAN="6">
                                        NewsItemsDataViewer
                                    </TD>
                                </TR>
                                <TR>
                                    <TD HEIGHT="20">
                                        ViewerSelectTreeButton
                                    </TD>
                                </TR>
                                <TR>
                                    <TD HEIGHT="25">
                                        CommentsButton
                                    </TD>
                                </TR>
                                <TR>
                                    <TD WIDTH="90" HEIGHT="68">
						NewsLogo
                                    </TD>
                                </TR>
                                <TR>
                                    <TD>
                                    </TD>
                                </TR>
                                <TR>
                                    <TD HEIGHT="25">
                                        BackButton
                                    </TD>
                                </TR>
                            </TABLE>
                        </g:PropertyValue>
                    </g:Property>
                </g:PropertyList>
            </g:Component>

		<g:Component Name="NewsLogo">
			<g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveActiveXWrapperTool_DLL&amp;Version=0&amp;Factory=ActiveXWrapper"/>
			<g:PropertyList Version="1">
				<g:Property Name="ProgID" Value="ShockwaveFlash.ShockwaveFlash.1"/>
				<g:Property Name="CommandDissemination" Value="false"/>
			</g:PropertyList>
		</g:Component>

		<g:Component Name="ViewerSelectTreeButton">
			<g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Button"/>
			<g:PropertyList Version="1">
				<g:Property Name="Label" Value="Browse"/>
				<g:Property Name="Radiobutton" Value="True"/>
				<g:Property Name="Style" Value="Radiobutton"/>
			</g:PropertyList>
		</g:Component>

		<g:Component Name="ViewerSelectHeadlinesButton">
			<g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Button"/>
			<g:PropertyList Version="1">
				<g:Property Name="Label" Value="Headlines"/>
				<g:Property Name="Radiobutton" Value="True"/>
				<g:Property Name="Style" Value="Radiobutton"/>
			</g:PropertyList>
		</g:Component>


            <g:Component Name="Tabs">
                <g:ComponentResource FingerprintID="net.Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=TabControl"/>
                <g:PropertyList Version="1">
                    <g:Property Name="Style" Value="SelectToolTabControl"/>
                </g:PropertyList>
            </g:Component>

            <g:Component Name="View2">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=ViewContainer"/>
                <g:PropertyList Version="1"/>
                <g:ComponentConnections>
                    <g:Connection Name="View2Layout" ConnectionID="0"/>
                </g:ComponentConnections>
            </g:Component>

            <g:Component Name="View2Layout">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=MultiCellLayout"/>
                <g:PropertyList Version="1">
                    <g:Property Name="Layout">
                        <g:PropertyValue>
                            <MULTIROW>
                                <ROW>
                                    <CELL>WebBrowserView</CELL>
                                </ROW>
                            </MULTIROW>
                        </g:PropertyValue>
                    </g:Property>
                </g:PropertyList>
            </g:Component>


		<g:Component Name="TreeView">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=TreeCtrl"/>
                <g:PropertyList Version="1">
                    <g:Property Name="Enabled" Value="True"/>
                    <g:Property Name="Visible" Value="True"/>
                </g:PropertyList>
            </g:Component>


            <g:Component Name="RTFView">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveTextTools_DLL&amp;Version=0&amp;Factory=TextView"/>
                <g:PropertyList Version="1">
                    <g:Property Name="ReadOnly" Value="true"/>
                    <g:Property Name="BackStyle" Value="transparent"/>
                    <g:Property Name="MenuStyle" Value="static"/>
                    <g:Property Name="BorderVisible" Value="false"/>
                </g:PropertyList>
            </g:Component>
            <g:Component Name="RTFHelpProvider">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=RTFHelpProvider"/>
                <g:PropertyList Version="1">
                    <g:Property Name="ContextHelpURL" Value="Help\Groove.net\tools\web_browser\web_browser.htm"/>
                    <g:Property Name="ContextHelpDisplayType" Value="0"/>
                    <g:Property Name="HelpDisplayName" Value="Web Browser"/>
                    <g:Property Name="HeaderText" Value="Web Browser"/>
                    <g:Property Name="Content" Value="">
                        <g:PropertyValue>
                            <![CDATA[{\rtf1\ansi\deff0\deftab720{\fonttbl{\f0\fswiss MS Sans Serif;}{\f1\froman\fcharset2 Symbol;}{\f2\fswiss\fprq2 Verdana;}{\f3\froman Times New Roman;}{\f4\froman\fprq2 Palatino;}{\f5\froman\fprq2 Times New Roman;}}
{\colortbl\red0\green0\blue0;\red0\green0\blue255;}
\deflang1033\pard\plain\f2\fs20\cf0 The Web Browser tool lets shared space members browse the Web together. For example, you or another member might guide other members on a path through several Web pages. 
\par 
\par To open a Web page, replace the words \ldblquote about:blank\rdblquote  in the URL address box with a URL address (for example, \plain\f2\fs20\cf1\ul http://www.groove.net/\plain\f2\fs20\cf0 ), and press Enter or the Go to URL button.
\par 
\par Click the \plain\f2\fs20\cf0\b Add Favorites \plain\f2\fs20\cf0 icon to store Web pages as Internet shortcut files. Click the \plain\f2\fs20\cf0\b Favorites List \plain\f2\fs20\cf0 icon to select and open your Internet shortcut files.
\par 
\par 
\par 
\par 
\par \pard\tx2280\tx2869\tx3480\tx4080\plain\f4\fs20 
\par \pard\plain\f5\fs24 
\par }]]>
                        </g:PropertyValue>
                    </g:Property>
                </g:PropertyList>
                <g:ComponentConnections>
                    <g:Connection Name="RTFView" ConnectionID="2"/>
                </g:ComponentConnections>
                <g:ExternalObjectConnections>
                    <g:Connection Name="HelpHandler" ConnectionID="0"/>
                </g:ExternalObjectConnections>
            </g:Component>


            <g:Component Name="WebBrowserView" DisplayName="Web Browser View">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveWebBrowserTool_DLL&amp;Version=2&amp;Factory=WebBrowserView"/>
                <g:ComponentConnections>
                    <g:Connection Name="WebBrowserEngine" ConnectionID="0"/>
                </g:ComponentConnections>
            </g:Component>
            <g:Component Name="WebBrowserEngine" Category="Engine" SingleInstance="True">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveWebBrowserTool_DLL&amp;Version=2&amp;Factory=WebBrowserEngine"/>
                <g:EngineDesc Tag="urn:groove.net:Engine"/>
            </g:Component>


		<g:Component Name="CommentsButton">
			<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Button" FingerprintID="Groove"/>
			<g:PropertyList Version="1">
				<g:Property Name="Style" Value="SmallTextButton"/>
				<g:Property Name="Label" Value="Comments"/>
				<g:Property Name="Tooltip" Value="Ctrl+C to view comments on this article"/>
				<g:Property Name="Mnemonic" Value="CTRL+C"/>
			</g:PropertyList>
		</g:Component>

		<g:Component Name="BackButton">
			<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Button" FingerprintID="Groove"/>
			<g:PropertyList Version="1">
				<g:Property Name="Style" Value="SmallTextButton"/>
				<g:Property Name="Label" Value="<<"/>
				<g:Property Name="Tooltip" Value="Go back"/>
			</g:PropertyList>
		</g:Component>

            <g:Component Name="Timer">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Timer"/>
                <g:PropertyList Version="1">
                    <g:Property Name="Interval" Value="1000"/>
                    <g:Property Name="Enable" Value="1"/>
                </g:PropertyList>
            </g:Component>

            <g:Component Name="ActiveDocumentEdit">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Edit"/>
                <g:PropertyList Version="1">
                    <g:Property Name="Style">
                        <g:PropertyValue>
                            <g:Item Name="Multiline"/>
                            <g:Item Name="VerticalScrollbar"/>
                        </g:PropertyValue>
                    </g:Property>
                </g:PropertyList>
            </g:Component>

            <g:Component Name="AddCommentStatic">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Static"/>
                <g:PropertyList Version="1">
                    <g:Property Name="Label" Value="Comment on this Article:"/>
                    <g:Property Name="Style" Value="Normal"/>
                    <g:Property Name="HAlignment" Value="Left"/>
                    <g:Property Name="VAlignment" Value="Bottom"/>
                    <g:Property Name="Font">
                        <g:FontDesc Color="#000000" Height="12" StyleBold="false" Typeface="Tahoma"/>
                    </g:Property>
                </g:PropertyList>
            </g:Component>

            <g:Component Name="AddCommentEdit">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Edit"/>
                <g:PropertyList Version="1">
                    <g:Property Name="Style">
                        <g:PropertyValue>
                            <g:Item Name="Multiline"/>
                            <g:Item Name="VerticalScrollbar"/>
                        </g:PropertyValue>
                    </g:Property>
                </g:PropertyList>
            </g:Component>

            <g:Component Name="MaintenanceTabContainer">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=ViewContainer"/>
                <g:PropertyList Version="1">
                    <g:Property Name="Background">
                        <g:BackgroundStyle Style="SectionBackground"/>
                    </g:Property>
                </g:PropertyList>
                <g:ComponentConnections>
                    <g:Connection Name="MaintenanceTabLayout" ConnectionID="0"/>
                </g:ComponentConnections>
                <g:PropertyList/>
            </g:Component>


<!--
	Layout of the "Maintenance" tab
-->
            <g:Component Name="MaintenanceTabLayout">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=HTMLTableLayout"/>
                <g:PropertyList Version="1">
                    <g:Property Name="Layout">
                        <g:PropertyValue>
                            <TABLE CELLPADDING="4">
                                <TR>
                                    <TD HEIGHT="30">
                                        ChannelsStatic
                                    </TD>
                                    <TD WIDTH="90">
                                        AddChannelButton
                                    </TD>
                                    <TD WIDTH="90">
                                        DeleteChannelButton
                                    </TD>
                                    <TD WIDTH="140">
                                        AddDefaultsButton
                                    </TD>
                                    <TD WIDTH="140">
                                        SaveProvidersButton
                                    </TD>
                                </TR>
                                <TR>
                                    <TD COLSPAN="5">
                                        ChannelListDataViewer
                                    </TD>
                                </TR>
                                <TR>
                                    <TD COLSPAN="5" HEIGHT="125">
                                        ChannelInfoContainer
                                    </TD>
                                </TR>
                            </TABLE>
                        </g:PropertyValue>
                    </g:Property>
                </g:PropertyList>
            </g:Component>


            <g:Component Name="ChannelInfoContainer">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=ViewContainer"/>
                <g:PropertyList Version="1"/>
                <g:ComponentConnections>
                    <g:Connection Name="ChannelInfoLayout" ConnectionID="0"/>
                </g:ComponentConnections>
            </g:Component>



            <g:Component Name="ChannelInfoLayout">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=MultiCellLayout"/>
                <g:PropertyList Version="1">
                    <g:Property Name="Layout">
                        <g:PropertyValue>
                            <MULTIROW>
                                <ROW>
                                    <CELL HEIGHT="20" WIDTH="100">
                                        NameStatic
                                    </CELL>
                                    <CELL>
                                        NameEdit
                                    </CELL>
                                    <CELL WIDTH="5"/>
                                </ROW>
                                <ROW>
                                    <CELL HEIGHT="5"/>
                                </ROW>
                                <ROW>
                                    <CELL HEIGHT="20" WIDTH="100">
                                        DataURLStatic
                                    </CELL>
                                    <CELL>
                                        DataURLEdit
                                    </CELL>
                                    <CELL WIDTH="5"/>
                                </ROW>
                                <ROW>
                                    <CELL HEIGHT="5"/>
                                </ROW>
                                <ROW>
                                    <CELL HEIGHT="20" WIDTH="100">
                                        SiteURLStatic
                                    </CELL>
                                    <CELL>
                                        SiteURLEdit
                                    </CELL>
                                    <CELL WIDTH="5"/>
                                </ROW>
                                <ROW>
                                    <CELL HEIGHT="5"/>
                                </ROW>
                                <ROW>
                                    <CELL HEIGHT="20" WIDTH="100">
                                        DescriptionStatic
                                    </CELL>
                                    <CELL>
                                        DescriptionEdit
                                    </CELL>
                                    <CELL WIDTH="5"/>
                                </ROW>
                                <ROW>
                                    <CELL HEIGHT="5"/>
                                </ROW>
                                <ROW>
                                    <CELL HEIGHT="20" WIDTH="100">
                                        ActivateStatic
                                    </CELL>
                                    <CELL>
                                        ActivateCheck
                                    </CELL>
                                    <CELL WIDTH="5"/>
                                </ROW>
                                <ROW>
                                    <CELL/>
                                </ROW>
                            </MULTIROW>
                        </g:PropertyValue>
                    </g:Property>
                </g:PropertyList>
            </g:Component>




            <g:Component Name="ChannelsStatic">
                <g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Static"/>
                <g:PropertyList Version="1">
                    <g:Property Name="Label" Value="Channels:"/>
                    <g:Property Name="Style" Value="Normal"/>
                    <g:Property Name="HAlignment" Value="Left"/>
                    <g:Property Name="VAlignment" Value="Bottom"/>
                    <g:Property Name="Font">
                        <g:FontDesc Color="#000000" Height="18" StyleBold="false" Typeface="Tahoma"/>
                    </g:Property>
                </g:PropertyList>
            </g:Component>


			<g:Component Name="NameStatic">
				<g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Static"/>
				<g:PropertyList>
					<g:Property Name="Font">
						<g:FontDesc Color="#800080" Height="10" StyleBold="True" Typeface="Arial"/>
					</g:Property>
					<g:Property Name="Label" Value="Name"/>
				</g:PropertyList>
			</g:Component>

			<g:Component Name="NameEdit">
				<g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Edit"/>
				<g:PropertyList Version="1">
					<g:Property Name="Enabled" Value="false"/>
				</g:PropertyList>
			</g:Component>

			<g:Component Name="DataURLStatic">
				<g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Static"/>
				<g:PropertyList>
					<g:Property Name="Font">
						<g:FontDesc Color="#800080" Height="10" StyleBold="True" Typeface="Arial"/>
					</g:Property>
					<g:Property Name="Label" Value="Data URL"/>
				</g:PropertyList>
			</g:Component>

			<g:Component Name="DataURLEdit">
				<g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Edit"/>
				<g:PropertyList Version="1">
					<g:Property Name="Enabled" Value="false"/>
				</g:PropertyList>
			</g:Component>

			<g:Component Name="SiteURLStatic">
				<g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Static"/>
				<g:PropertyList>
					<g:Property Name="Font">
						<g:FontDesc Color="#800080" Height="10" StyleBold="True" Typeface="Arial"/>
					</g:Property>
					<g:Property Name="Label" Value="Site URL"/>
				</g:PropertyList>
			</g:Component>

			<g:Component Name="SiteURLEdit">
				<g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Edit"/>
				<g:PropertyList Version="1">
					<g:Property Name="Enabled" Value="false"/>
				</g:PropertyList>
			</g:Component>

			<g:Component Name="DescriptionStatic">
				<g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Static"/>
				<g:PropertyList>
					<g:Property Name="Font">
						<g:FontDesc Color="#800080" Height="10" StyleBold="True" Typeface="Arial"/>
					</g:Property>
					<g:Property Name="Label" Value="Description"/>
				</g:PropertyList>
			</g:Component>

			<g:Component Name="DescriptionEdit">
				<g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Edit"/>
				<g:PropertyList Version="1">
					<g:Property Name="Enabled" Value="false"/>
				</g:PropertyList>
			</g:Component>

			<g:Component Name="ActivateStatic">
				<g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Static"/>
				<g:PropertyList>
					<g:Property Name="Font">
						<g:FontDesc Color="#800080" Height="10" StyleBold="True" Typeface="Arial"/>
					</g:Property>
					<g:Property Name="Label" Value="Active Channel"/>
				</g:PropertyList>
			</g:Component>

			<g:Component Name="ActivateCheck">
				<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Button" FingerprintID="Groove"/>
				<g:PropertyList Version="1">
					<g:Property Name="Checkbox" Value="true"/>
					<g:Property Name="Style" Value="Checkbox"/>
					<g:Property Name="Tooltip" Value="Check to activate this Channel."/>
				</g:PropertyList>
			</g:Component>

			<g:Component Name="AddChannelButton">
				<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Button" FingerprintID="Groove"/>
				<g:PropertyList Version="1">
					<g:Property Name="Style" Value="SmallTextButton"/>
 					<g:Property Name="Label" Value="Add Channel"/>
 					<g:Property Name="Tooltip" Value="Ctrl+N to add a channel"/>
 					<g:Property Name="Mnemonic" Value="CTRL+N"/>
					<g:Property Name="Menu" Value="AddChannelMenu"/>
				</g:PropertyList>
			</g:Component>

                    <g:Component Name="AddChannelMenu">
				<g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Menu"/>
				<g:PropertyList Version="1">
					<g:Property Name="UICommands">
						<g:PropertyValue>
							<g:UICommand URL="loadURL" Label="From URL..."/>
							<g:UICommandSeparator URL="CLT_Sep"/>
							<g:UICommand URL="custom" Label="Create a custom channel by searching Moreover..."/>
						</g:PropertyValue>
					</g:Property>
				</g:PropertyList>
                    </g:Component>

			<g:Component Name="DeleteChannelButton">
				<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Button" FingerprintID="Groove"/>
				<g:PropertyList Version="1">
					<g:Property Name="Style" Value="SmallTextButton"/>
 					<g:Property Name="Label" Value="Delete"/>
 					<g:Property Name="Tooltip" Value="Ctrl+D to remove channel"/>
 					<g:Property Name="Mnemonic" Value="CTRL+D"/>
				</g:PropertyList>
			</g:Component>

			<g:Component Name="AddDefaultsButton">
				<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Button" FingerprintID="Groove"/>				
				<g:PropertyList Version="1">
					<g:Property Name="Style" Value="SmallTextButton"/>
					<g:Property Name="Label" Value="Add Channel Lists"/>
					<g:Property Name="Tooltip" Value="Ctrl+F to add default providers"/>
					<g:Property Name="Mnemonic" Value="CTRL+F"/>
					<g:Property Name="Menu" Value="AddDefaultsMenu"/>
				</g:PropertyList>
			</g:Component>

                    <g:Component Name="AddDefaultsMenu">
				<g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Menu"/>
				<g:PropertyList Version="1">
					<g:Property Name="UICommands">
						<g:PropertyValue>
							<g:UICommand URL="http://w.moreover.com/categories/ocs/ocsdirectory_0_1.rdf" Label="Moreover news channels"/>
							<g:UICommand URL="http://www.newsisfree.com/ocs/directory.xml" Label="NewsIsFree news channels"/>
							<g:UICommand URL="http://10.am/extra/ocsdirectory.xml" Label="10.am news channels"/>
							<g:UICommand URL="http://www.ourfavoritesongs.com/sourcesHotlist.opml" Label="Userland favourite channels"/>
							<g:UICommand URL="http://www.groksoup.com/Sites/OCS/ocsdirectory.xml" Label="GrokSoup channels"/>
							<g:UICommand URL="http://www.xmltree.com/export/ocs.cfm" Label="XMLTree channels"/>
							<g:UICommand URL="http://rendezvoo.net/Top/xmlqueryall.asp" Label="Rendezvoo.net venues and spaces"/>
							<g:UICommandSeparator URL="CLT_Sep"/>
							<g:UICommand URL="loadWeb" Label="Load channels from the Web..."/>
							<g:UICommand URL="loadFile" Label="Load channels from file..."/>
						</g:PropertyValue>
					</g:Property>
				</g:PropertyList>
                    </g:Component>

			<g:Component Name="SaveProvidersButton">
				<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Button" FingerprintID="Groove"/>				
				<g:PropertyList Version="1">
					<g:Property Name="Style" Value="SmallTextButton"/>
					<g:Property Name="Label" Value="Save Channel List"/>
					<g:Property Name="Tooltip" Value="Ctrl+S to save your list of channels"/>
					<g:Property Name="Mnemonic" Value="CTRL+S"/>
					<g:Property Name="Menu" Value="SaveProvidersMenu"/>
				</g:PropertyList>
			</g:Component>

			<g:Component Name="SaveProvidersMenu">
				<g:ComponentResource FingerprintID="Groove" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Menu"/>
				<g:PropertyList Version="1">
					<g:Property Name="UICommands">
						<g:PropertyValue>
							<g:UICommand URL="saveOPML" Label="Save as file..."/>
							<g:UICommandSeparator URL="CLT_Sep"/>
							<g:UICommand URL="saveGRV" Label="Create a telespace template from this channel list..."/>
						</g:PropertyValue>
					</g:Property>
				</g:PropertyList>
			</g:Component>


<!--
	Data mgmt components for the channel list:
		ChannelListModelGlue
		ChannelListCollection
		ChannelListColumnHeaders
		ChannelListRecordSetEngine
		ChannelListDataViewer
-->

		<g:Component Name="ChannelListModelGlue">
			<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveDataViewerTool_DLL&amp;Version=0&amp;Factory=ModelGlue" FingerprintID="Groove"/>
			<g:PropertyList Version="1"/>
			<g:ComponentConnections>
				<g:Connection Name="ChannelListCollection" ConnectionID="0"/>
				<g:Connection Name="ChannelListRecordSetEngine" ConnectionID="1"/>
			</g:ComponentConnections>
		</g:Component>

		<g:Component SingleInstance="True" Name="ChannelListCollection">
			<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveListComponents_DLL&amp;Version=0&amp;Factory=ToolCollectionsComponent" FingerprintID="Groove"/>
		</g:Component>

		<g:Component SingleInstance="True" Category="Engine" Name="ChannelListRecordSetEngine">
			<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveListComponents_DLL&amp;Version=0,4&amp;Factory=RecordSetEngine3" FingerprintID="Groove"/>
			<g:EngineDesc Tag="urn:groove.net:RecordSetEngine"/>
			<g:PropertyList Version="1">
				<g:Property Name="EnableAccessControl" Value="true"/>
				<g:Property Name="ClassInfoList">
					<g:PropertyValue>
						<g:ClassInfo Name="urn:cabezal.com:NewsClientChannelRecord" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveListComponents_DLL&amp;Version=0&amp;Factory=Record"/>
						<g:Fields>
							<g:Field Name="UNID" TriggerUnread="false"/>
							<g:Field Name="ok" TriggerUnread="false"/>
							<g:Field Name="Name" TriggerUnread="false"/>
							<g:Field Name="DataURL" TriggerUnread="false"/>
							<g:Field Name="SiteURL" TriggerUnread="false"/>
							<g:Field Name="Description" TriggerUnread="false"/>
							<g:Field Name="IsActive" TriggerUnread="false"/>
						</g:Fields>
					</g:PropertyValue>
				</g:Property>
			</g:PropertyList>
			<g:ComponentConnections>
				<g:Connection Name="ChannelListCollection" ConnectionID="0"/>
			</g:ComponentConnections>
		</g:Component>

		<g:Component Name="ChannelListDataViewer">
			<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveDataViewerTool_DLL&amp;Version=0&amp;Factory=DataViewer" FingerprintID="Groove"/>
			<g:PropertyList Version="1">
				<g:Property Name="Views">
					<g:PropertyValue>
						<g:DataViewerView Name="Main" Default="True">
							<g:DataViewerColumn Name="IsActive" Label="" Width="15" ShowTwisty="0" Indent="15" ReadOnly="1">
								<g:IconDesc Height="13" Width="13" URL="grooveFile:///ToolData\cabezal.com\Tools\NewsClient\CrossIconImages.jpg" MaskURL="grooveFile:///ToolData\cabezal.com\Tools\NewsClient\CrossIconImagesMask.bmp"/>
							</g:DataViewerColumn>
							<g:DataViewerColumn Name="Name" Label="Name" DataType="String" Width="75%" ReadOnly="1"/>
							<g:DataViewerColumn ReadOnly="1" Name="_Created" Width="130" DataType="DateTime" Label="Created"/>
							<g:DataViewerColumn Name="Reliability" Width="70" DataType="String" Label="" ReadOnly="1"/>
						</g:DataViewerView>
					</g:PropertyValue>
				</g:Property>
				<g:Property Name="Sorts">
					<g:PropertyValue>
						<g:DataViewerSort Name="ByAscName" Column="Name" DataType="String" Order="Ascending"/>
						<g:DataViewerSort Name="ByAscUNID" Column="UNID" DataType="String" Order="Ascending"/>
						<g:DataViewerSort Name="ByAscok" Column="ok" DataType="String" Order="Ascending"/>
						<g:DataViewerSort Name="ByOrdinal" Order="Ordinal"/>
					</g:PropertyValue>
				</g:Property>
				<g:Property Name="GridLineDescriptor">
					<g:PropertyValue>
						<g:DataViewerGridLineDescriptor Style="Solid" Color="#DCDCDC" Orientation="Both" Visible="0"/>
					</g:PropertyValue>
				</g:Property>
				<g:Property Name="SingleSelection" Value="true"/>
			</g:PropertyList>
			<g:ComponentConnections>
				<g:Connection Name="ChannelListModelGlue" ConnectionID="0"/>
				<g:Connection Name="ChannelListColumnHeaders" ConnectionID="1"/>
			</g:ComponentConnections>
		</g:Component>

		<g:Component Name="ChannelListColumnHeaders">
			<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Header" FingerprintID="Groove"/>
		</g:Component>



<!--
	Data components for the news items:
		NewsItemsModelGlue
		NewsItemsCollection
		NewsItemsRecordSetEngine
		NewsItemsDataViewer
		NewsItemsColumnHeaders
-->

		<g:Component Name="NewsItemsModelGlue">
			<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveDataViewerTool_DLL&amp;Version=0&amp;Factory=ModelGlue" FingerprintID="Groove"/>
			<g:PropertyList Version="1"/>
			<g:ComponentConnections>
				<g:Connection Name="NewsItemsCollection" ConnectionID="0"/>
				<g:Connection Name="NewsItemsRecordSetEngine" ConnectionID="1"/>
			</g:ComponentConnections>
		</g:Component>

		<g:Component SingleInstance="True" Name="NewsItemsCollection">
			<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveListComponents_DLL&amp;Version=0&amp;Factory=ToolCollectionsComponent" FingerprintID="Groove"/>
		</g:Component>

		<g:Component SingleInstance="True" Category="Engine" Name="NewsItemsRecordSetEngine">
			<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveListComponents_DLL&amp;Version=0,4&amp;Factory=RecordSetEngine3" FingerprintID="Groove"/>
			<g:EngineDesc Tag="urn:groove.net:RecordSetEngine"/>
			<g:PropertyList Version="1">
				<g:Property Name="EnableAccessControl" Value="false"/>
				<g:Property Name="ClassInfoList">
					<g:PropertyValue>
						<g:ClassInfo Name="urn:cabezal.com:NewsClientItemRecord" URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveListComponents_DLL&amp;Version=0&amp;Factory=Record"/>
						<g:Fields>
							<g:Field Name="UNID" TriggerUnread="true"/>
							<g:Field Name="ok" TriggerUnread="true"/>
							<g:Field Name="Title" TriggerUnread="true"/>
							<g:Field Name="Link" TriggerUnread="true"/>
							<g:Field Name="Description" TriggerUnread="true"/>
						</g:Fields>
					</g:PropertyValue>
				</g:Property>
			</g:PropertyList>
			<g:ComponentConnections>
				<g:Connection Name="NewsItemsCollection" ConnectionID="0"/>
			</g:ComponentConnections>
		</g:Component>

		<g:Component Name="NewsItemsDataViewer">
			<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveDataViewerTool_DLL&amp;Version=0&amp;Factory=DataViewer" FingerprintID="Groove"/>
			<g:PropertyList Version="1">
				<g:Property Name="Views">
					<g:PropertyValue>
						<g:DataViewerView Name="Main" Default="True">
							<g:DataViewerColumn ReadOnly="1" Name="_IsRead" Width="15" Label="">
								<g:IconDesc Height="13" Width="13" URL="grooveFile:///ToolData\groove.net\CommonData\UnreadIconImages.jpg" MaskURL="grooveFile:///ToolData\groove.net\CommonData\UnreadIconImagesMask.bmp"/>
							</g:DataViewerColumn>
							<g:DataViewerColumn Name="Title" Label="Title" DataType="String" Width="60%" ReadOnly="1"/>
							<g:DataViewerColumn Name="Channel" Label="Channel" DataType="String" Width="19%" ShowTwisty="0" Indent="15" ReadOnly="1"/>
							<g:DataViewerColumn Name="_Created" Width="19%" DataType="DateTime" Label="Received" ReadOnly="1"/>
						</g:DataViewerView>
					</g:PropertyValue>
				</g:Property>
				<g:Property Name="Sorts">
					<g:PropertyValue>
						<g:DataViewerSort Name="ByAscTitle" Column="Title" DataType="String" Order="Ascending"/>
						<g:DataViewerSort Name="ByDescCreated" Order="Descending" DataType="DateTime" Column="_Created"/>
						<g:DataViewerSort Name="ByAscChannel" Column="Channel" DataType="String" Order="Ascending"/>
						<g:DataViewerSort Name="ByAscUNID" Column="UNID" DataType="String" Order="Ascending"/>
						<g:DataViewerSort Name="ByAscChannelUNID" Column="ChannelUNID" DataType="String" Order="Ascending"/>
						<g:DataViewerSort Name="ByAscok" Column="ok" DataType="String" Order="Ascending"/>
						<g:DataViewerSort Name="ByOrdinal" Order="Ordinal"/>
					</g:PropertyValue>
				</g:Property>
				<g:Property Name="GridLineDescriptor">
					<g:PropertyValue>
						<g:DataViewerGridLineDescriptor Style="Solid" Color="#DCDCDC" Orientation="Both" Visible="0"/>
					</g:PropertyValue>
				</g:Property>
				<g:Property Name="Painters">
					<g:PropertyValue>
						<g:Painter ElementTag="urn:groove.net:RichText" Handler="RichTextPainter"/>
					</g:PropertyValue>
				</g:Property>
				<g:Property Name="Editors">
					<g:PropertyValue>
						<g:Editor ElementTag="urn:groove.net:RichText" Handler="RichTextEditor"/>
					</g:PropertyValue>
				</g:Property>
				<g:Property Name="SingleSelection" Value="false"/>
			</g:PropertyList>
			<g:ComponentConnections>
				<g:Connection Name="NewsItemsModelGlue" ConnectionID="0"/>
				<g:Connection Name="NewsItemsColumnHeaders" ConnectionID="1"/>
			</g:ComponentConnections>
			<g:ComponentGroup>
				<g:Component Name="RichTextPainter">
					<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveTextTools_DLL&amp;Version=0&amp;Factory=TextPainter" FingerprintID="Groove"/>
				</g:Component>
				<g:Component Name="RichTextEditor">
					<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveTextTools_DLL&amp;Version=0,3&amp;Factory=TextView2" FingerprintID="Groove"/>
					<g:PropertyList Version="1">
						<g:Property Name="CellPaste" Value="true"/>
						<g:Property Name="BackStyle" Value="transparent"/>
						<g:Property Name="BorderVisible" Value="false"/>
					</g:PropertyList>
				</g:Component>
			</g:ComponentGroup>
		</g:Component>

		<g:Component Name="NewsItemsColumnHeaders">
			<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=Header" FingerprintID="Groove"/>
		</g:Component>


<!--
	The data delegate gluecode
-->

			<g:Component Name="NewsClientDataGlue" SingleInstance="True">
				<g:ComponentResource URL="http://www.cabezal.com/Cabezal/Components/Tools/NewsClient/CabezalNewsClient.osd?Package=com.cabezal.Tools.NewsClient.CabezalNewsModelGlue_DLL&amp;Version=0&amp;Factory=CabezalNewsModelGlue" FingerprintID="com.cabezal"/>
				<g:ComponentConnections>
					<g:Connection Name="NewsItemsRecordSetEngine" ConnectionID="0"/>
					<g:Connection Name="ChannelListRecordSetEngine" ConnectionID="1"/>
				</g:ComponentConnections>
				<g:PropertyList Version="1"/>
			</g:Component>

<!--
	The main gluecode
-->
		<g:Component Name="NewsClientGlue">
			<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=ScriptHost2" FingerprintID="Groove"/>
				
			<g:ComponentConnections>
				<g:Connection ConnectionID="1"  Name="OuterViewContainer"/>
				<g:Connection ConnectionID="2"  Name="OuterLayoutWithTabs"/>
				<g:Connection ConnectionID="3"  Name="OuterLayoutWithoutTabs"/>
				<g:Connection ConnectionID="4"  Name="Tabs" />
				<g:Connection ConnectionID="5"  Name="View1Layout"/>
				<g:Connection ConnectionID="6"  Name="CommentsButton" />
				<g:Connection ConnectionID="7"  Name="BackButton" />
				<g:Connection ConnectionID="8"  Name="AddChannelButton" />
				<g:Connection ConnectionID="9"  Name="AddChannelMenu" />
				<g:Connection ConnectionID="10" Name="DeleteChannelButton" />
				<g:Connection ConnectionID="11" Name="AddDefaultsButton" />
				<g:Connection ConnectionID="12" Name="AddDefaultsMenu" />
				<g:Connection ConnectionID="13" Name="SaveProvidersButton" />
				<g:Connection ConnectionID="13" Name="SaveProvidersMenu" />
				<g:Connection ConnectionID="14" Name="NameEdit" />
				<g:Connection ConnectionID="15" Name="DataURLEdit" />
				<g:Connection ConnectionID="16" Name="SiteURLEdit" />
				<g:Connection ConnectionID="17" Name="DescriptionEdit" />
				<g:Connection ConnectionID="18" Name="ActivateCheck" />
				<g:Connection ConnectionID="19" Name="TreeView" />
				<g:Connection ConnectionID="20" Name="ViewerSelectTreeButton" />
				<g:Connection ConnectionID="21" Name="ViewerSelectHeadlinesButton" />
				<g:Connection ConnectionID="22" Name="ChannelListModelGlue" />
				<g:Connection ConnectionID="23" Name="ChannelListRecordSetEngine" />
				<g:Connection ConnectionID="24" Name="ChannelListDataViewer" />
				<g:Connection ConnectionID="25" Name="NewsItemsModelGlue" />
				<g:Connection ConnectionID="26" Name="NewsItemsRecordSetEngine" />
				<g:Connection ConnectionID="27" Name="NewsItemsDataViewer" />
				<g:Connection ConnectionID="28" Name="WebBrowserEngine" />
				<g:Connection ConnectionID="29" Name="WebBrowserView" />
				<g:Connection ConnectionID="30" Name="Timer" />
				<g:Connection ConnectionID="31" Name="NewsLogo" />
				<g:Connection ConnectionID="32" Name="DownloadGlue" />
			</g:ComponentConnections>

			<g:ExternalObjectConnections>
				<g:Connection Name="ToolCommandContainer" ConnectionID="0"/>
			</g:ExternalObjectConnections>

			<g:PropertyList Version="1"/>
				
			<TYPELIB LIBID="{9A25D120-FA0E-11d4-BBAE-00010246B3E5}" NAME="GrooveDataViewerTool" MAJORVER="1" MINORVER="0"/>
			<TYPELIB LIBID="{FB1EBAB1-C159-11d3-80B6-00500487887B}" NAME="GrooveCollectionComponents" MAJORVER="1" MINORVER="0"/>

			<SCRIPT SRC="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveGlobalHelperFunctions_GSL&amp;Version=0,1&amp;Factory=Open" FingerprintID="Groove"/>
			<SCRIPT SRC="http://www.cabezal.com/Cabezal/Components/Tools/NewsClient/CabezalNewsClient.osd?Package=com.cabezal.Tools.NewsClient.CabezalNewsClientMD5_GSL&amp;Version=0&amp;Factory=Open" FingerprintID="com.cabezal"/>
			<SCRIPT>
				<![CDATA[

/*
tbd:
- fix the "what the f* do I do with this" problem
	- builtin lists of channels (or, fetch known channel lists from:  syndic8, etc): bootstrapping is really hard
		- present a tree, various categorisations
	- first-use popup to choose source for your channels list?
-

	- notifiers: point to space/tool URL when click
	- move hash to groove, for performance
	- comments config: send to back-end; "all comments are public"
	- checkbox per channel: "download attachments"; or by role...
	- download channel images into cache, name by channel UNID (need reliable downloader!)
	- multiple select in channels list;  multiple delete;  multiple isactive??
	- "mark all read" leaves prev-unread button enabled
	- retain focus in the treeview?
	- add new news item is resetting the webbrowser... (markread...)?
	- show comments through into newsitems view & tree
	- dispatch comments back to center (SOAP? POST? need config.  Key by item URL)
	- read comments from center (key by item URL)
	- role for "add comments"
	- access control for guest to fetch channels but not edit IsActive status
	- AutoRun framework
	- NavigateTogether
	- "enclosures" (RSS0.92) or "content:item" (RSS1.0), for clausy
		<item><enclosure url="http://www.scripting.com/mp3s/weatherReportSuite.mp3" length="12216320" type="audio/mpeg" /></item>
	  or
		<content:items><rdf:Bag><rdf:li>
			<content:item rdf:about="http://example.org/item/content.svg">
				<content:format rdf:resource="http://www.w3.org/2000/svg" />
			</content:item>
		</rdf:li></rdf:Bag></content:items>
	  and ways to attach them into the Groove space (documentshare)
	- ?bot-driven special user, for clausy (no round-robin at all)?
*/

/**
  * ---------------------------------------------------
  * Global variables
  * ---------------------------------------------------
  */
var UI = false;
var g_Null;
var g_Misc;
var g_StorageManager;
var g_AccountManager;
var g_WindowManager;
var g_DeviceAccount;
var g_Intl;
var g_Awareness;
var g_Telespace;
var g_MembersAwareness;
var g_FileSystem;
var g_TempServices;
var g_Transport;
var g_Preferences = null;

var g_Bootstrap;
var g_CurrentTab;													// The currently selected top-level tab
var g_NewsClientUI;													// Object managing the "Tool Descriptor" UI
var g_MaintenanceUI;												// Object managing the "Project Files" UI
var g_pICommentsForm;
var g_pICommentsWindow;
var g_pICommentsDispatch;
var g_SM = GrooveScriptFunctions.CreateNewObject("Groove.StorageManager");
var g_Channel = null;												// The channel we're currently working with
var g_CurrentChannel = 0;	// currently selected channel record ID
var g_CurrentItemRecordID = 0;
var g_CurrentItemUNID = null;
var g_CurrentItemURL = null;
var g_CurrentItemTitle = null;
var g_CurrentWebURL = null;
var g_nChannelsSelected = 0;

var g_ObjectEntryStore;
var g_ACLCookie;
var g_bCanDoMaintenance = true;

var g_DocumentImage;
var g_DocumentImageSelected;
var g_FolderImage;
var g_FolderImageSelected;

var g_FullPersistRootPath;

var g_RSSClient;	// the RSS Client class

var UICommandContainer;
var CustomTB = false;
var bCommandsShown = false;

var g_pTelespaceIdentityPropertyList;
var g_bFollowMode;

// Command Bar URLs
var NEWSCLIENT_TOOL_SEPARATOR = "NewsClientTool_Separator";
var NEWSCLIENT_TOOL_COPY_AS_LINK = "NewsClientTool_CopyAsLink";
var NEWSCLIENT_TOOL_NEXT = "NewsClientTool_Next";
var NEWSCLIENT_TOOL_PREVIOUS = "NewsClientTool_Previous";
var NEWSCLIENT_TOOL_NEXT_UNREAD = "NewsClientTool_Next_Unread";
var NEWSCLIENT_TOOL_PREVIOUS_UNREAD = "NewsClientTool_Previous_Unread";
var NEWSCLIENT_TOOL_UNREAD_MENU = "NewsClientTool_Unread_Menu";
var NEWSCLIENT_TOOL_MARK_ALL_READ = "NewsClientTool_Mark_All_Read";
var NEWSCLIENT_TOOL_MARK_ALL_UNREAD = "NewsClientTool_Mark_All_UnRead";
var NEWSCLIENT_TOOL_MARK_SELECTED_UNREAD = "NewsClientTool_Mark_Selected_UnRead";
var NEWSCLIENT_TOOL_MARK_SELECTED_READ = "NewsClientTool_Mark_Selected_Read";

// Command Bar ToolTips
var NEWSCLIENT_TOOL_TOOLTIP_COPY_AS_LINK = "Copy As Link";
var NEWSCLIENT_TOOL_TOOLTIP_NEXT = "Navigate Next";
var NEWSCLIENT_TOOL_TOOLTIP_PREVIOUS = "Navigate Previous";
var NEWSCLIENT_TOOL_TOOLTIP_NEXT_UNREAD = "Navigate Next Unread";
var NEWSCLIENT_TOOL_TOOLTIP_PREVIOUS_UNREAD = "Navigate Previous Unread";
var NEWSCLIENT_TOOL_TOOLTIP_UNREAD_MENU = "Unread Options";

/**
  * ---------------------------------------------------
  * Initialisation and termination
  * ---------------------------------------------------
  */

function Initialize()
{
	// ---- globals

	g_Null             = GrooveScriptFunctions.CreateNewObject("");
	pISystemServices   = GrooveScriptFunctions.CreateNewObject("Groove.SystemServices");
	g_Misc             = GROOVE_GLOBAL_MISC_POINTER; // pISystemServices.Misc;
	g_StorageManager   = pISystemServices.StorageManager;
	g_AccountManager   = pISystemServices.AccountManager;
	g_WindowManager    = GrooveScriptFunctions.CreateNewObject("Groove.WindowManager");
	var pAccountSvcs   = GrooveScriptFunctions.CreateNewObject("Groove.AccountServices");
	g_DeviceAccount    = pAccountSvcs.DeviceAccount;
	g_Intl             = GrooveScriptFunctions.CreateNewObject("Groove.Internationalization");
	g_Awareness        = GrooveScriptFunctions.CreateNewObject("Groove.AwarenessServices");
	g_Telespace        = PropertyList.OpenProperty(PROPERTY_TELESPACE);
	g_MembersAwareness = g_Awareness.OpenTelespaceMembersAwareness( g_Telespace );
	g_FileSystem       = GrooveScriptFunctions.CreateNewObject( "Groove.Win32FileSystemServices" );
	g_TempServices     = GrooveScriptFunctions.CreateNewObject( "Groove.TemporaryFileServices" );
	g_Transport        = GrooveScriptFunctions.CreateNewObject("Groove.TransportPackage");


	// Get the Persist Path (not particularly useful)
	var pIStorageURISyntax = GrooveScriptFunctions.CreateNewObject("Groove.StorageURISyntax");
	g_FullPersistRootPath = pIStorageURISyntax.OpenPersistRootPath();

	// ---- component connections

	// Link to the CabezalNewsClientLibrary DLL
	g_RSSClient = GrooveScriptFunctions.CreateNewObject("CabezalNewsClientLibrary.cNewsClient");
	// and listen to its events
	// ConnectObject( g_RSSClient, "RSSClient_", true ); 	// last "true" means listen even to non-default event sources

	InitFollowMode();

	// ---- tabs

	Tabs.AppendTab("News", "NewsClientContainer");
	Tabs.AppendTab("Maintenance","MaintenanceTabContainer");

	// ---- the WebBrowser control

	WebBrowserEngine.BrowseAloneHomePage = "about:blank";
	WebBrowserEngine.BrowseTogetherHomePage = "about:blank";
	WebBrowserView.BrowseTogetherByDefault = false;
	WebBrowserView.IgnoreNavigateTogether = true;

	// ---- bootstrap the channel list
	
	g_Bootstrap = false;
	if( PropertyList.PropertyExists( "bootstrap" ) )
		g_Bootstrap = PropertyList.OpenPropertyAsBool( "bootstrap" );

	if( ChannelListModelGlue.Collection.IsEmpty() )
	{
		// Is there bootstrap information from OneTimeInitialize?
		var bBS = false;
		var sBootstrapURL = GetPreferenceAsString( "ChannelProviderURL", "" )
		if( sBootstrapURL != "" )
		{
			// Load it in!
			g_Bootstrap = true;
			loadProviderList_Raw( sBootstrapURL, true );
			bBS = true;
		}

		if( !bBS )
		{
			var pElBoot = GetPreferenceAsElement( "Channels" )
			if( pElBoot )
			{
				// Load it in!
				g_Bootstrap = true;
				loadProviderList_Groove( pElBoot, true );
				bBS = true;
			}
		}

		if( !bBS )
		{
			// Is there a bootstrap .ocs file?
			var pParser = GrooveScriptFunctions.CreateNewObject("CabezalNewsClientLibrary.cNewsClient");
			var sDefault = "file:///" + g_FullPersistRootPath + "ToolData\\cabezal.com\\Tools\\NewsClient\\default.opml";
			var pChannel = pParser.GetNewRSSSource( sDefault, "_DefaultSource", false );
			if( pChannel )
			{
				// Gotcha!  Grab the raw XML and parse it ourselves.
				var pXMLDoc = pChannel.getDoc();
				if( pXMLDoc )
					g_Bootstrap = parseProviderList( pXMLDoc, true );
			}
		}
	}
	PropertyList.SetPropertyAsBool( "bootstrap", g_Bootstrap );

	// ---- Init the News Client UI.
	//g_NewsClientUI = new NewsClientUI;

	// ---- Init the Maintenance UI.
	//g_MaintenanceUI = new MaintenanceUI;

	// Listen to changes in the roles and permissions
	g_ObjectEntryStore = null;
	if (PropertyList.PropertyExists(PROPERTY_OBJECT_ENTRY_STORE))
	{
		g_ObjectEntryStore = PropertyList.OpenProperty(PROPERTY_OBJECT_ENTRY_STORE);
		var ScopeURLURI = PropertyList.OpenProperty(PROPERTY_TOOL).ObjectTypesScopeURL;
		var ScopeURL = ScopeURLURI.String;
		g_ACLCookie = g_ObjectEntryStore.AddAggregatedListener( ScriptHostComponent.IGrooveAggregatedObjectEntryStoreListener, ScopeURL);
	}
}

function Terminate()
{
	TerminateTree();
	if( CustomTB ) DisconnectObject( UICommandContainer );
	if( g_ObjectEntryStore ) g_ObjectEntryStore.RemoveAggregatedListener( g_ACLCookie );
	// DisconnectObject( g_RSSClient );
	DisconnectObject( g_pTelespaceIdentityPropertyList );
}

function InitFollowMode()
{
	g_pTelespaceIdentityPropertyList = CreateOrOpenPropertyList(PropertyList, g_Telespace, 0, 1, ScriptHostComponent, "TelespaceIdentityPropertyList", true);

	// Is follow mode on?
	if( g_pTelespaceIdentityPropertyList.PropertyExists("ToolNavigationMode"))
	{
		g_bFollowMode = g_pTelespaceIdentityPropertyList.OpenPropertyAsLong("ToolNavigationMode");
	}
	else
	{
		var TelespacePropertyList = CreateOrOpenPropertyList(PropertyList, g_Telespace, 0, 3, ScriptHostComponent, "", false);
		if (TelespacePropertyList != null)
		{
			if (TelespacePropertyList.PropertyExists("ToolNavigationMode"))
				g_bFollowMode = TelespacePropertyList.OpenPropertyAsLong("ToolNavigationMode");
		}		
	}
}

function OnSetUIProperties()
{
	UI = true;

	// By default, we're viewing headlines
	ViewerSelectTreeButton.CheckState = false;
	ViewerSelectHeadlinesButton.CheckState = true;

	// Disable the comments button until we're ready
	CommentsButton.Enabled = false;
	BackButton.Enabled = false;

	// Disable the "delete channel" button until there's a channel selected
	EnableDisableUI();

	// Set up the TreeView with its images and default contents
	InitialiseTree();

	SelectTab("NewsClientContainer");

	// ---- Make sure the timer is ticking (should happen automatically, but just in case anyone stopped it!)
	Timer.Stop();
	Timer.Start();

	// ---- Set up the branding image

	// Set up the branding (jpg image or flash movie)
	// - default is the cabezal logo
	// - preference string "LogoURL" defines a download-to-install jpeg image
	// - preference string "FlashURL" defines a download-to-install flash movie
	// - preference string "FlashFile" defines an already-downloaded flash movie

	var bFlash = false;
	var sFlashFile;
	var sLogoURL;
	var sFlashURL;

// tbd
//	sLogoURL = GetPreferenceAsString( "LogoURL", "" );

	sFlashURL = GetPreferenceAsString( "FlashURL", "" );
	if( sFlashURL == "" )
	{
		sFlashFile = GetPreferenceAsString( "FlashFile", "CabezalNewsClient.swf" );
	}
	else
	{
		// Check to see whether we already downloaded the movie
		sFlashFile = hash( sFlashURL );
		var f = g_FullPersistRootPath + "ToolData\\cabezal.com\\Tools\\NewsClient\\" + sFlashFile;
		if( g_FileSystem.DoesFileExist( f ) )
			sFlashURL = "";
	}
	if( sFlashURL == "" )
	{
		// Point at a local movie
		var f = g_FullPersistRootPath + "ToolData\\cabezal.com\\Tools\\NewsClient\\" + sFlashFile;
		NewsLogo.Movie = f;
	}
	else
	{
		// Point at the Web-based movie while we download it
		NewsLogo.Movie = sFlashURL;
		var f = g_FullPersistRootPath + "ToolData\\cabezal.com\\Tools\\NewsClient\\" + sFlashFile;
		DownloadFile( sFlashURL, f );
	}
	NewsLogo.Stop();
	NewsLogo.Rewind();


	// ---- Follow Me?
	if( g_bFollowMode )
	{
		// Go wherever the crowd is
		if (PropertyList.PropertyExists("FollowMode_URL"))
		{
			var sURL = PropertyList.OpenPropertyAsString("FollowMode_URL");
			if( sURL != "" )
			{
				var pURLNavigator = UIPropertyList.OpenProperty(UIPROPERTY_URLNAVIGATOR);
//				pURLNavigator.NavigateToURL( sURL, false );
			}
		}
	}

//	NewsItemsModelGlue.Collection.UseNamedSort( "ByDescCreated", true );
}

function OnRevokeUIProperties()
{
	TerminateTree();
	UI = false;
}

function ConfigureBranding()
{
}


function OnConnectToExternalObject(i_Object, i_ConnectionID)
{
	if (0 == i_ConnectionID)
	{
		if (CustomTB == false)
		{
			UICommandContainer = i_Object;
			ConnectObject(UICommandContainer, "UICommandContainer");
		}
		ShowUICommands();
	}		
}
	
function OnUnconnectFromExternalObjects()
{
	if (CustomTB == false)
	{
		if (typeof UICommandContainer != "undefined")
		{
			HideUICommands();
			DisconnectObject(UICommandContainer);
		}
	}
}

// Include this function if you want to allow the consumer of this delegate
// to pass in their own toolbar which this delegate will use instead of the 
// global one.  Note that the consumer must pass in their toolbar in their
// OnSetUIProperties call, NOT in their Initialize since we are not sited yet
// and will fail when trying to insert the commands.
function SetCustomToolBar(i_ToolBarComponent)
{
	if (typeof UICommandContainer != "undefined")
	{
		HideUICommands();
		DisconnectObject(UICommandContainer);
	}
	CustomTB = true;
	UICommandContainer = i_ToolBarComponent;
	ConnectObject(UICommandContainer, "UICommandContainer");
	ShowUICommands();
}


/**
  * ---------------------------------------------------
  * Generic helper functions
  * ---------------------------------------------------
  */


function InputBox( sQuestion, sTitle )
{
	var Window = UIPropertyList.OpenProperty(UIPROPERTY_TOP_LEVEL_WINDOW);
	var Account = OpenAccountFromPropertyList(PropertyList);
	return App.GrooveInputBox(Window, Account, sQuestion, GrooveInputBoxStyle_None, "", sQuestion, sTitle );
}


function MakeQuery( strItemName, Key )
{
	return ("@" + strItemName + "='" + Key + "'");
}


function encodeURI( sText )
{
	// Escsape sText so it's suitable for use in a URL querystring
	return escape( sText );
}


function Debug( sDebug )
{
//	App.AddNotificationItem( sDebug );
}

function Info( sInfo )
{
	App.AddNotificationItem( sInfo );
}

function Error( sError )
{
	GrooveScriptFunctions.DoMessageBox( sError );
}


function GetPreferences()
{
	if( g_Preferences )
		return g_Preferences;

	var pPrefs = g_Telespace.PreferencesProvider.PropertyList;
	var sToolURL = PropertyList.OpenProperty(PROPERTY_TOOL).CanonicalURL;
	var pElBootstrap = null;
	if( !pPrefs.PropertyExists( sToolURL + "_BootstrapProperties" ) )
		return null;

	var sPropName = sToolURL + "_BootstrapProperties"
	try
	{
		g_Preferences = pPrefs.OpenPropertyAsPropertyList( sPropName );
	}
	catch( _ex )
	{
	}
	return g_Preferences;
}


function GetPreferenceAsString( sPrefName, sPrefDefault )
{
	// Use the bootstrap props list
	var p = GetPreferences();
	if( !p )
		return sPrefDefault;
	
	if( !p.PropertyExists( sPrefName ) )
		return sPrefDefault;

	return p.OpenPropertyAsString( sPrefName );
}

function GetPreferenceAsElement( sPrefName )
{
	// Use the bootstrap props list
	var p = GetPreferences();
	if( !p )
		return null;
	
	if( !p.PropertyExists( sPrefName ) )
		return null;

	var pRet = null;
	try
	{
		var pEl = p.OpenPropertyAsElement( sPrefName );
		pRet = pEl.OpenContentElement(0);
	}
	catch( _ex )
	{
	}
	return pRet;
}

function MarkRecordRead( pEngine, i_RecordID, bRead, bToggle )
{
	if (typeof bRead == "undefined") bRead = true;
	var pITransaction = g_Telespace.OpenTransaction(false);
	try
	{
		if( pEngine.HasRecord(i_RecordID) )
		{
			var Record = pEngine.OpenRecord(i_RecordID);
			if (typeof bToggle!="undefined" && bToggle == true) bRead = !Record.OpenFieldAsBool("_IsRead");	
			if (Record.OpenFieldAsBool("_IsRead") != bRead) pEngine.MarkRecordRead(i_RecordID, bRead);
		}
		pITransaction.Commit();
	}
	catch(e)
	{
		pITransaction.Abort();
		Error( "Error: " + e.description );
	}
}

function MarkAllRecordsRead( pEngine, bRead )
{
	g_WindowManager.ShowWaitCursor();
	if (typeof bRead == "undefined") bRead = true;
	var pITransaction = g_Telespace.OpenTransaction(false);
	try
	{			
		var RecordIDEnum = pEngine.OpenRecordIDEnum();
		pEngine.MarkMultipleRecordsRead(RecordIDEnum, bRead);
		pITransaction.Commit();
	}
	catch(e)
	{
		pITransaction.Abort();
		Error( "Error: " + e.description );
	}
	g_WindowManager.ShowWaitCursor(false);
}

function GetURLToCurrentRecord()
{
	if( !g_CurrentItemRecordID ) return null;
	var ToolURL = PropertyList.OpenProperty(PROPERTY_CANONICAL_URL);
	var pURI = GROOVE_GLOBAL_MISC_POINTER.OpenURI(ToolURL);
	pURI.SetQueryPart("RecordID", g_CurrentItemRecordID);
	return pURI.String;
}

function DownloadFile( sURL, sDestPath )
{
	DownloadGlue.GetScriptDispatch().DownloadFile( sURL, sDestPath );
}

function DownloadGlue_DownloadQueued( sURL, sDesc )
{
	Debug( "Download queued: " + sURL )
}

function DownloadGlue_DownloadComplete( sURL, sDesc )
{
	Debug( "Download complete: " + sURL )
}

function DownloadGlue_DownloadFailed( sURL, sErrorDesc )
{
	Debug( "Download failed: " + sURL + ", " + sErrorDesc )
}

/**
  * ---------------------------------------------------
  * tbd: Follow mode
  * ---------------------------------------------------
  */

function TelespaceIdentityPropertyListOnPropertyChanged(i_Key, i_Value, i_LocallyGenerated)
{
	// Is this the follow mode state changing?
	if (i_Key == "ToolNavigationMode")
	{
		g_InFollowMode = (i_Value == "0") ? false : true;
		if (g_InFollowMode)
		{
			// We are going into follow mode; navigate to the current story if we are ui active
			if (PropertyList.PropertyExists("FollowMode_URL"))
			{
				if (UI)
				{
					var sURL = PropertyList.OpenPropertyAsString("FollowMode_URL");
					var pURLNavigator = UIPropertyList.OpenProperty(UIPROPERTY_URLNAVIGATOR);
//					pURLNavigator.NavigateToURL( sURL, false );
				}
			}
			else
			{
				if( GetURLToCurrentRecord() )
					PropertyList.SetProperty("FollowMode_URL", GetURLToCurrentRecord(), GroovePropertyFlag_Default);
				else
					PropertyList.RemoveProperty("FollowMode_URL", GroovePropertyFlag_Default);
			}
		}								
	}
}

function OnPropertyChanged(i_Key, i_Value, i_LocallyGenerated)
{
	if (i_Key == "FollowMode_URL")
	{
		if ((UI) && (!i_LocallyGenerated) && (g_InFollowMode))
		{
			var sURL = i_Value;
			var pURLNavigator = UIPropertyList.OpenProperty(UIPROPERTY_URLNAVIGATOR);
//			pURLNavigator.NavigateToURL( sURL, false );
		}
	}
}



/**
  * ---------------------------------------------------
  * Tab switching control logic
  * ---------------------------------------------------
  */

function SelectTab(TabName)
{
	Tabs.SetSelection(TabName);
	SetTabContents(TabName);
	g_CurrentTab = TabName;
}

function Tabs_OnSelectionChanged(i_URL, i_KeyStates)
{
	if (i_URL != g_CurrentTab)
	{
		// Update the tab contents
		SetTabContents(i_URL);
		g_CurrentTab = i_URL;
	}
}

function SetTabContents(TabName)
{				
	// Remove the current sub form
	var MCellSizeObj = GrooveScriptFunctions.CreateNewObject("Groove.MultiCellLayoutControlInfo");
	var MCellObj = MCellSizeObj.Cell();
	MCellObj.Name = "TabContents";
	
	OuterLayoutWithTabs.RemoveCellContents(MCellObj);
	OuterLayoutWithoutTabs.RemoveCellContents(MCellObj);

	// Add the requested sub form
	OuterLayoutWithTabs.AddControlByName(TabName, MCellObj);
	OuterLayoutWithoutTabs.AddControlByName(TabName, MCellObj);

	if( TabName=="MaintenanceTabContainer" )
		HideUICommands();
	else
		ShowUICommands();
}


/**
  * Radiobuttons to switch between tree- and headline-view
  * (tbd: navigate-together?)
  */

function ViewerSelectTreeButton_OnCommand( i_pIUICommand )
{
	ViewerSelectTreeButton.CheckState = true;
	ViewerSelectHeadlinesButton.CheckState = false;
	var pLayoutInfo = GrooveScriptFunctions.CreateNewObject("Groove.HTMLTableLayoutControlInfo");
	var pObj = pLayoutInfo.Cell();
	pObj.Name = "Viewer";
	View1Layout.RemoveCellContents( pObj );
	View1Layout.AddControlByName( "TreeView", pObj );
}

function ViewerSelectHeadlinesButton_OnCommand( i_pIUICommand )
{
	ViewerSelectTreeButton.CheckState = false;
	ViewerSelectHeadlinesButton.CheckState = true;
	var pLayoutInfo = GrooveScriptFunctions.CreateNewObject("Groove.HTMLTableLayoutControlInfo");
	var pObj = pLayoutInfo.Cell();
	pObj.Name = "Viewer";
	View1Layout.RemoveCellContents( pObj );
	View1Layout.AddControlByName( "NewsItemsDataViewer", pObj );
}


/**
  * "Comments" button
  * and launching the comments form
  */

function CommentsButton_OnCommand(i_pIUICommand)
{
	// Check that a news article is currently being viewed
	if( g_CurrentItemRecordID == 0 ) return;
	if( g_CurrentItemUNID == null ) return;
	
	if (GrooveWindowResult_Cancel == ShowCommentsWindow())
		return;
}

function GetCommentsForm()
{
	if (null == g_pICommentsForm)
	{
		//  Check for the comments tool, add it if necessary
		var CommentsURL = "http://www.cabezal.com/Cabezal/Components/Tools/NewsClient/CabezalNewsClient.osd?Package=com.cabezal.Tools.NewsClient.CabezalNewsComments_TPL&Version=0&Factory=Open";
		var pIToolContainer = PropertyList.OpenProperty(PROPERTY_TOOL_CONTAINER);
		if (!pIToolContainer.DoesToolByCategoryExist(CommentsURL))
		pIToolContainer.AddFromTemplateURL(CommentsURL, CommentsURL);

		//  Create form for item details tool
		var pICommentsTool = pIToolContainer.OpenToolByCategory(CommentsURL);
		var pIUITool = pICommentsTool.UITool;
		g_pICommentsForm = pIUITool.CreateForm();
	}
	return g_pICommentsForm;
}

function GetCommentsDispatch()
{
	if (null == g_pICommentsDispatch)
	{
		var pForm = GetCommentsForm();
		var pFormHost = pForm.OpenDelegateComponent();
		var pFormGlue = pFormHost.GetScriptDispatch();
		g_pICommentsDispatch = pFormGlue;
	}
	return g_pICommentsDispatch;
}

function GetCommentsWindow()
{
	if (null == g_pICommentsWindow)
	{
	//  Get Window Account
	var pIWindowAccount = UIPropertyList.OpenProperty(UIPROPERTY_WINDOW_ACCOUNT);

	//  Set properties for window we will create
	var pIWindowProperties = GrooveScriptFunctions.CreateNewObject("Groove.WindowProperties");
	pIWindowProperties.Style = "PopupWindow";
	pIWindowProperties.ParentWindow = UIPropertyList.OpenProperty(UIPROPERTY_TOP_LEVEL_WINDOW);
	pIWindowProperties.Resizable = false;
	pIWindowProperties.Caption = "Item Details";
	pIWindowProperties.CaptionVisible = true;
	pIWindowProperties.Visible = true;
	pIWindowProperties.CloseButton = false;
	pIWindowProperties.BorderVisible = false;
	pIWindowProperties.HelpButton = false;

	//Create the new window
	var pIWindowManager = GrooveScriptFunctions.CreateNewObject("Groove.WindowManager");
	var CurrentDate = new Date();
	var WindowName = "Comments" + CurrentDate.getTime();
	g_pICommentsWindow = pIWindowManager.CreateGrooveWindowForForm( pIWindowAccount, WindowName,	pIWindowProperties, GetCommentsForm()	);
	}

	return g_pICommentsWindow;
}

function ShowCommentsWindow()
{
	// Pass our context to the comments form
	GetCommentsDispatch().SetContext( g_CurrentItemRecordID, g_CurrentItemUNID )

	//  Set system menu options so that there is no way to manipulate it
	var WindowMenuCommands = 
		GrooveWindowMenuCommand_Restore +
		GrooveWindowMenuCommand_Size +
		GrooveWindowMenuCommand_Minimize +
		GrooveWindowMenuCommand_Maximize +
		GrooveWindowMenuCommand_Close;
	GetCommentsWindow().ShowWindowMenuCommands(WindowMenuCommands, false);

	//  Display window in modal fashion
	var WindowResult = GetCommentsWindow().DoModal();

	return WindowResult;
}




/**
  * Controls for the "maintenance" form
  */

function AddChannelMenu_OnCommand(i_pIUICommand)
{
	var URL = i_pIUICommand.CommandURL;
	var id = i_pIUICommand.ID;

	if( URL=="custom" )
	{
		// Create a custom channel by searching a provider (Moreover, possibly others)
		var IBResult = InputBox("Search Moreover for word(s):", "Custom Channel");
		if (GrooveDialogBoxResultCode_OK != IBResult.Result)
			return;
		var sName = "moreover search - " + IBResult.Data;
		var sData = "http://www.moreover.com/cgi-local/page?o=rss&query=" + encodeURI( IBResult.Data );
		var sHome = "http://www.moreover.com/"
		var sDesc = "Custom channel created by searching Moreover for '" + IBResult.Data + "'";
		AddChannel( sName, sData, sHome, sDesc, true, "RSS1", "http://i.moreover.com/pics/rss.gif", "144", "16" );
		return;
	}

	if( URL=="loadURL" )
	{
		var IBResult = InputBox("URL of the channel's data feed:", "New Channel");
		if (GrooveDialogBoxResultCode_OK != IBResult.Result)
			return;
		var DataURL = IBResult.Data;
		AddChannelURL( DataURL, true );
		return;
	}
}


function AddChannelURL( DataURL, bReportErrors )
{
	// Connect to the RSS data source
	// and get the channel information

	var sID = "_AddChannel";
	var pRSS = GrooveScriptFunctions.CreateNewObject("CabezalNewsClientLibrary.cNewsClient");
	var pChannel = pRSS.GetNewRSSSource( DataURL, sID, false );
	var pCh = null;
	if( pChannel )
	{
		pCh = pChannel.getChannel();
	}

	if( !pCh )
	{
		var sErr = "Can't open the URL or understand its content (" + DataURL + ")";
		if( bReportErrors )
			Error( sErr );
		else
			Info( sErr );
		return;
	}

	var Name = pCh.getTitle();
	var SiteURL = pCh.getLink();
	var Description = pCh.getDesc();
	var RSSVersion = pCh.getVersion();
	var sImage = pCh.getImageURL();
	var sImageWidth = pCh.getImageWidth();
	var sImageHeight = pCh.getImageHeight();

	NameEdit.Text = Name;
	DataURLEdit.Text = DataURL;
	SiteURLEdit.Text = SiteURL;
	DescriptionEdit.Text = Description;
	ActivateCheck.CheckState = true;

	AddChannel( Name, DataURL, SiteURL, Description, true, RSSVersion, sImage, sImageWidth, sImageHeight );
}


function GetChannelIDByUNID( sChannelUNID )	// returns the recordID, or -1
{
	var RecordID = -1;
	if( ChannelListModelGlue.Collection.IsEmpty() )
		return -1;

	// Dumb method: sequential trawl through the channel list.  .Find() is slow and nasty.
	var pITransaction = g_Telespace.OpenTransaction(true);
	try
	{
		var RecordIDEnum = ChannelListRecordSetEngine.OpenRecordIDEnum();
		while( RecordIDEnum.HasMore() )
		{
			var nRecordID = RecordIDEnum.OpenNext();
			if( ChannelListModelGlue.Cursor.HasRecord(nRecordID) )
			{
				var pIRecord = ChannelListModelGlue.OpenRecord(nRecordID);
				var sUNID = pIRecord.OpenField( "UNID" );
				if( sUNID == sChannelUNID )
				{
					RecordID = nRecordID;
					break;
				}
			}
		}
		pITransaction.EndRead();
	}
	catch( e )
	{
		pITransaction.Abort();
		Error( "Error in GetChannelIDByUNID: " + e.description );
	}

	// Finally, may have a recordID.
	return RecordID;
}

function GetChannelRecordByUNID( sChannelUNID )	// returns the record, or null
{
	var pRecord = null;
	if( ChannelListModelGlue.Collection.IsEmpty() )
		return null;

	// Dumb method: sequential trawl through the channel list.  .Find() is slow and nasty.
	var pITransaction = g_Telespace.OpenTransaction(true);
	try
	{
		var RecordIDEnum = ChannelListRecordSetEngine.OpenRecordIDEnum();
		while( RecordIDEnum.HasMore() )
		{
			var nRecordID = RecordIDEnum.OpenNext();
			if( ChannelListModelGlue.Cursor.HasRecord(nRecordID) )
			{
				var pIRecord = ChannelListModelGlue.OpenRecord(nRecordID);
				var sUNID = pIRecord.OpenField( "UNID" );
				if( sUNID == sChannelUNID )
				{
					pRecord = pIRecord;
					break;
				}
			}
		}
		pITransaction.EndRead();
	}
	catch( e )
	{
		pITransaction.Abort();
		Error( "Error in GetChannelRecordByUNID: " + e.description );
	}

	// Finally, may have a recordID.
	return pRecord;
}

function hash( s )
{
	var pDigest = new MD5();
	pDigest.init();
	pDigest.update( s );
	pDigest.finish();
	return pDigest.getString();
}

function UpdateChannel( sName, sDataURL, sSiteURL, sDescription, bActivate, sRSSVersion, sImageURL, sImageWidth, sImageHeight )
{
}

function AddChannel( sName, sDataURL, sSiteURL, sDescription, bActivate, sRSSVersion, sImageURL, sImageWidth, sImageHeight )
{
	// Construct a UNID for the channel
	// just based on its DataURL
	var sUNID = hash( sDataURL.toLowerCase() );

	// Does this channel already exist?
	var nID = GetChannelIDByUNID( sUNID );
	if( nID != -1 )
	{
		Info( "The channel '" + sName + "' is already in your list." );
		return;
	}

	// Create a record to give to add to the ChannelListRecordSetEngine
	var pIRecord = ChannelListModelGlue.CreateRecord("urn:cabezal.com:NewsClientChannelRecord");

	// Set the fields in the record
	pIRecord.SetField( "UNID", sUNID );
	pIRecord.SetField( "ok", "1" );
	pIRecord.SetField( "Name", sName );
	pIRecord.SetField( "DataURL", sDataURL );
	pIRecord.SetField( "SiteURL", sSiteURL );
	pIRecord.SetField( "Description", sDescription );
	pIRecord.SetField( "ImageURL", sImageURL );
	pIRecord.SetField( "ImageHeight", sImageHeight );
	pIRecord.SetField( "ImageWidth", sImageWidth );
	pIRecord.SetField( "IsActive", bActivate );
	pIRecord.SetField( "RSSVersion", sRSSVersion );
	pIRecord.SetField( "LastPoll", g_Intl.CreateDate().RawDateTime );
	pIRecord.SetFieldAsDouble( "NPolls", 0 );
	pIRecord.SetField( "LastSuccess", g_Intl.CreateDate().RawDateTime );
	pIRecord.SetFieldAsDouble( "NSuccesses", 0 );
	pIRecord.SetField( "Reliability", "0/0" );

	// Add the record
	ChannelListModelGlue.AddRecord(pIRecord);
	g_CurrentChannel = pIRecord.RecordID;

	// Poll now if this channel is active
	PollActiveNow( g_CurrentChannel );
}


function ChannelListDataViewer_OnDataViewerBeginEditCell( i_DataViewerName, i_RecordID, 	i_ColumnName, i_pData, i_pIEventResult )
{
	// We don't allow edit-in-place at all
	i_pIEventResult.Result = false;
}

function ChannelListDataViewer_OnDataViewerEndEditCell	( i_DataViewerName, 	i_RecordID, i_ColumnName, i_pOldData, i_pNewData, i_Result )
{
	// We don't allow edit-in-place at all
	return;
}

function ChannelListDataViewer_OnDataViewerRecordSelectionChanged( i_DataViewerName, i_RecordID )
{
	var RecordID = ChannelListDataViewer.GetIDOfFocusRow();
	g_CurrentChannel = 0;
	g_nChannelsSelected = 0;

	//  If no entry in the list has been selected, just exit
	if (-1 == RecordID)
	{	
		Error("no entry selected");
		return;
	}

/*
	var pEnum = ChannelListDataViewer.GetIDsOfSelectedRows();
	while( pEnum.HasMore() )
	{
		g_nChannelsSelected++;
		pEnum.OpenNext();
	}
*/
g_nChannelsSelected=1;


	if( g_nChannelsSelected == 1 )
	{
		// Display the selected record
		var pITransaction = g_Telespace.OpenTransaction(true);
		try
		{
			//  Get the record
			if( ChannelListModelGlue.Cursor.HasRecord(RecordID) )
				{
				g_CurrentChannel = RecordID;
				var pIRecord = ChannelListModelGlue.OpenRecord(RecordID);
	
				//  Get the fields in the record
				NameEdit.Text            = pIRecord.OpenField("Name");
				DataURLEdit.Text         = pIRecord.OpenField("DataURL");
				SiteURLEdit.Text         = pIRecord.OpenField("SiteURL");
				DescriptionEdit.Text     = pIRecord.OpenField("Description");
				ActivateCheck.CheckState = pIRecord.OpenField("IsActive");
				}
			pITransaction.EndRead();
		}
		catch (e)
		{
			Error( "Error in OnDataViewerRecordSelectionChanged: " + e.description );
			pITransaction.Abort();
		}
	}
	else
	{
		NameEdit.Text            = "";
		DataURLEdit.Text         = "";
		SiteURLEdit.Text         = "";
		DescriptionEdit.Text     = "";
		ActivateCheck.CheckState = false;
	}
	EnableDisableUI();
}


function EnableDisableUI()
{
	// Switch the buttons in the maintenance page
	AddChannelButton.Enabled = ChannelListRecordSetEngine.CanAddRecord();
	AddDefaultsButton.Enabled = ChannelListRecordSetEngine.CanAddRecord();
	if( g_CurrentChannel==0 )
	{
		ActivateCheck.Enabled = false;
		DeleteChannelButton.Enabled = false;
	}
	if( g_CurrentChannel>0 )
	{
		ActivateCheck.Enabled = ChannelListRecordSetEngine.CanReplaceRecord();
		DeleteChannelButton.Enabled = ChannelListRecordSetEngine.CanRemoveRecord();
	}
	if( g_nChannelsSelected > 1 )
	{
		ActivateCheck.Enabled = false;
		DeleteChannelButton.Enabled = ChannelListRecordSetEngine.CanRemoveRecord();
	}

	SaveProvidersButton.Enabled = !ChannelListModelGlue.Collection.IsEmpty();

	// disable the "maintenance" tab (or remove the tab control completely)
	// if they can't do any maintenance at all
	var bCanDoMaintenance = ChannelListRecordSetEngine.CanAddRecord() || ChannelListRecordSetEngine.CanReplaceRecord() || ChannelListRecordSetEngine.CanRemoveRecord();
	if( g_Bootstrap )
		bCanDoMaintenance = false;
	if( bCanDoMaintenance != g_bCanDoMaintenance )
	{
		g_bCanDoMaintenance = bCanDoMaintenance;
		if( bCanDoMaintenance )
		{
			OuterViewContainer.LayoutByName = "OuterLayoutWithTabs";
		}
		else
		{
			OuterViewContainer.LayoutByName = "OuterLayoutWithoutTabs";
			// Make sure we switch onto the News tab!
			SelectTab("NewsClientContainer");
		}
	}
}



function DeleteChannelButton_OnCommand(i_pIUICommand)
{
	// Which row(s) are selected?
	var pEnum = ChannelListDataViewer.GetIDsOfSelectedRows();
	while( pEnum.HasMore() )
	{
		var RecordID = pEnum.OpenNext();
		if (-1 == RecordID) 	return;

		var pITransaction = g_Telespace.OpenTransaction(false);
		try
		{
			//  Remove the record if it exists
			if (ChannelListModelGlue.Cursor.HasRecord(RecordID))
			{
				// Remove news items from this channel
				RemoveNews( RecordID, false );
				// Delete the channel
				ChannelListModelGlue.DeleteRecord(RecordID);
				pITransaction.Commit();
			}
			else
			{
				pITransaction.Abort();
			}
		}
		catch (e)
		{
			Error( "Error in DeleteChannelButton: " + e.description );
			pITransaction.Abort();
		}
	}

	// Clear the user interface
	NameEdit.Text = "";
	DataURLEdit.Text = "";
	SiteURLEdit.Text = "";
	DescriptionEdit.Text = "";
	ActivateCheck.CheckState = false;
	g_CurrentChannel = 0;

	EnableDisableUI();
}


function ActivateCheck_OnCommand( i_pIUICommand )
{
	// Reset the "active" flag on the current record
	var bActive = ActivateCheck.CheckState;
	var RecordID = ChannelListDataViewer.GetIDOfFocusRow();
	if (-1 == RecordID) 	return;

	var pITransaction = g_Telespace.OpenTransaction(false);
	try
	{
		// Set the IsActive flag
		if (ChannelListModelGlue.Cursor.HasRecord(RecordID))
		{
			var pIRecord = ChannelListModelGlue.OpenRecord( RecordID );
			pIRecord.SetFieldAsBool( "IsActive", bActive );
			pITransaction.Commit();
		}
		else
		{
			pITransaction.Abort();
		}
	}
	catch (e)
	{
		Error( "Error in ActivateCheck: " + e.description );
		pITransaction.Abort();
	}
	// Remove news items if channel is inactive; poll if channel is active
	if( bActive )
		PollActiveNow( RecordID );
	else
		RemoveNews( RecordID, true );
}


/**
  * ---------------------------------------------------
  * Load and save channel lists
  * ---------------------------------------------------
  */

function AddDefaultsMenu_OnCommand( i_pIUICommand )
{
	var URL = i_pIUICommand.CommandURL;
	var id = i_pIUICommand.ID;

	if( URL=="test" )
	{
		// Just several test sources, obsolete now
		AddChannel( "Groovelog local", "file:///c:/etc/today.rss10.xml", "http://groovelog.agora.co.uk/", "groovelog in /etc", true, "RSS1", "", "", "" );
		AddChannel( "Groovelog Rss1.0", "http://groovelog.agora.co.uk/groove+log/groovelog.nsf/today.rss10.xml", "http://groovelog.agora.co.uk/", "groovelog Rss1.0", true, "RSS1", "", "", "" );
		AddChannel( "Groovelog Rss0.91", "http://groovelog.agora.co.uk/groove+log/groovelog.nsf/today.rss.xml", "http://groovelog.agora.co.uk/", "groovelog Rss0.91", true, "RSS", "", "", "" );
		AddChannel( "rendezvoo local", "file:///c:/etc/xmlquery.xml", "http://rendezvoo.net/Top/", "rendezvoo in /etc", true, "RSS1", "", "", "" );
		AddChannel( "rendezvoo Top", "http://rendezvoo.net/Top/xmlquery.asp", "http://rendezvoo.net/Top/", "rendezvoo.net/Top", true, "RSS1", "", "", "" );
		AddChannel( "moreover - biotech", "http://p.moreover.com/cgi-local/page?c=Biotech%20news&o=rss", "http://www.moreover.com/", "moreover biotech news", true, "RSS", "", "", "" );
		return;
	}

	if( URL=="loadWeb" )
	{
		// Load from URL
		var IBResult = InputBox("URL of the provider's channel list:", "Load Provider List");
		if (GrooveDialogBoxResultCode_OK != IBResult.Result)
			return;
		URL = IBResult.Data;
	}

	if( URL=="loadFile" )
	{
		// Load from disk
		var FileDialogResult = App.OpenFileDialog (
			"Open...",			//  title
			"*.opml, *.ocs, *.rdf",	//  filter
			"---garage---",		//  initial directory, deliberately unlikely
			"",				//  initial filename
			g_DeviceAccount,		//  account
			1,				//  filter index
			false				//  multi-select
			);
		//  If cancel button selected or no file name specified, just exit now		
		if( (GrooveDialogBoxResultCode_Cancel == FileDialogResult.Result) || (FileDialogResult.Data == "") )
			return;
		URL = "file:///" + FileDialogResult.Data;
	}

	if( URL=="" ) return;
	loadProviderList( URL );
}


function loadProviderList( URL )
{
	var ConfirmStr = "Loading a provider's list of channels may take several minutes.  Do you want to continue?";
	var Window = UIPropertyList.OpenProperty(UIPROPERTY_TOP_LEVEL_WINDOW);
	var Account = OpenAccountFromPropertyList(PropertyList);
	var RetVal = App.GrooveMessageBox(Window, Account, ConfirmStr, "Load?", GrooveMessageBoxStyle_YesNo, 256);
	if (RetVal != GrooveMessageBoxResultCode_Yes)
		return;
	loadProviderList_Raw( URL, false );
}

function loadProviderList_Raw( URL, bEnableByDefault )
{
	// Load the URL
	var pParser = GrooveScriptFunctions.CreateNewObject("CabezalNewsClientLibrary.cNewsClient");
	var pChannel = pParser.GetNewRSSSource( URL, "_DefaultSource", false );
	if( !pChannel )
	{
		var sErr = "Can't open the channel list from the news provider (" + URL + ").\nPlease try again later.";
		Error( sErr );
		return;
	}
	// Gotcha!  Grab the raw XML and parse it ourselves.
	var pXMLDoc = pChannel.getDoc();
	if( !pXMLDoc )
	{
		var sErr = "Can't read the channel list from the news provider (" + URL + ").  Please try again later.";
		Error( sErr );
		return;
	}
	// Several different formats.  Oh well...
	if( !parseProviderList( pXMLDoc, bEnableByDefault ) )
	{
		Error( "The news provider's channel list (" + URL + ") is empty or in an unknown format.  Please try again later." );
	}
}


function loadProviderList_Groove( pEl, bEnableByDefault )
{
	// Given a Groove XML element, parse it.
	// To do this, convert into an MSXML DOM and follow on.
	var pBIStream = pEl.Serialize( GrooveSerializeType_XML, GrooveCharEncodingType_UTF8, GrooveSerializeOption_NoProlog + GrooveSerializeOption_NoFragmentWrapper)
	var sTmpPath = g_TempServices.CreateTemporaryFile( "xml" );
	var pOut = g_Misc.StreamFactory.CreateByteOutputStreamFromFile( sTmpPath, false, false );
	pBIStream.ReadToStream( -1, pOut );
	pOut.Close();
	loadProviderList_Raw( sTmpPath, bEnableByDefault );
	g_TempServices.DeleteTemporaryFile( sTmpPath );
}


function parseProviderList( pDoc, bEnableByDefault )
{
	// Ok.  We have a provider list... (pDoc is an MSXML DOM document, not a Groove XML document!)
	// Should be in either OPML or OCS format.  Otherwise we'll fail gracefully.
	g_WindowManager.ShowWaitCursor();
	var i;
	var bAny = false;
	var pEls = pDoc.childNodes;
	for( i=0; i<pEls.length; i++ )
	{
		var pEl = pEls.nextNode();
		switch( pEl.nodeName.toLowerCase() )
		{
			case "opml":
				parseProviderOPML( pEl, bEnableByDefault );
				bAny = true;
				break;

			case "rdf:rdf":
				parseProviderOCS( pEl, bEnableByDefault );
				bAny = true;
				break;
		}
	}
	g_WindowManager.ShowWaitCursor(false);
	return bAny;
}


function parseProviderOPML( pEl, bEnableByDefault )
{
	// OPML document.
	// Everything's inside a "body" child of the OPML element.
	var i;
	var pBodys = pEl.getElementsByTagName( "body" );
	if( pBodys.length < 1 )
	{
		Error( "The channel list is empty." );
		return;
	}
	var pBody = pBodys.nextNode();
	var pChannels = pBody.getElementsByTagName( "outline" );
	if( pChannels.length < 1 )
	{
		Error( "The channel list is empty." );
		return;
	}
	Info( "Reading " + pChannels.length + " channels from the provider list" );
	for( i=0; i<pChannels.length; i++ )
	{
		var pChannel = pChannels.nextNode();
		var sType = attribute( pChannel, "version" );
		var sName = attribute( pChannel, "title" );
		var sDesc = attribute( pChannel, "description" );
		var sURL  = attribute( pChannel, "htmlUrl" );
		var sData = attribute( pChannel, "xmlUrl" );

		// No image info in the OPML file; gather this later
		var sImage = "";
		var sImageWidth = "";
		var sImageHeight = "";

		AddChannel( sName, sData, sURL, sDesc, bEnableByDefault, sType, sImage, sImageWidth, sImageHeight );
	}
}

function parseProviderOCS( pEl, bEnableByDefault )
{
	// OCS (RDF) document.
	// The root rdf:RDF contains rdf:description which contains an rdf:description for each channel.
	// Each channel has one or more rdf:description elements; we're only interested in those with certain ocs:format types.
	var i;
	var j;
	var k;
	var n = 0;
	var pBodys = pEl.getElementsByTagName( "rdf:description" );
	if( pBodys.length < 1 )
	{
		Error( "The channel list is empty." );
		return;
	}
	for( var j=0; j<pBodys.length; j++ )
	{
		var pBody = pBodys.nextNode();
		var pChannels = pBody.getElementsByTagName( "rdf:description" );
		if( pChannels.length > 0 ) Info( "Reading " + pChannels.length + " channels from the provider list" );
		for( i=0; i<pChannels.length; i++ )
		{
			var pChannel = pChannels.nextNode();
			var sURL = attribute( pChannel, "about" );
			var sName = element( pChannel, "dc:title" );
			var sDesc = element( pChannel, "dc:description" );
			var pChannelFormats = pChannel.getElementsByTagName( "rdf:description" );
			var pChannelFormat = null;
			var ok = false;
			var sVer = "";

			// No image info in the OCS file; gather this later
			var sImage = "";
			var sImageWidth = "";
			var sImageHeight = "";

			var bBlogify = false;
			if( pChannelFormats.length == 0 )
			{
				// The blogspace list doesn't detail each channel under multiple formats,
				// just a single "ocs:format" element for each channel.
				var sOCSFormat = element( pChannel, "ocs:format" );
				if( sOCSFormat=="http://my.netscape.com/rdf/simple/0.9/" ) 			{ ok=true; sVer="RSS" }
				if( sOCSFormat=="http://my.netscape.com/publish/formats/rss-0.91.dtd" ) 	{ ok=true; sVer="RSS" }
				if( sOCSFormat=="http://purl.org/rss/1.0/" ) 					{ ok=true; sVer="RSS1" }
				bBlogify = true;
			}
			else
			{
				for( k=0; k<pChannelFormats.length; k++ )
				{
					pChannelFormat = pChannelFormats.nextNode();
					var sOCSFormat = element( pChannelFormat, "ocs:format" );
					if( sOCSFormat=="http://my.netscape.com/rdf/simple/0.9/" ) 			{ ok=true; sVer="RSS" }
					if( sOCSFormat=="http://my.netscape.com/publish/formats/rss-0.91.dtd" ) 	{ ok=true; sVer="RSS" }
					if( sOCSFormat=="http://purl.org/rss/1.0/" ) 					{ ok=true; sVer="RSS1" }
					if( ok ) break;
				}
			}
			if( ok )	// got a channel feed in an acceptable format
			{
				var sData;
				if( bBlogify )
					sData = "http://blogspace.com/rss/feeds/blogify?url=" + escape(sURL);
				else
					sData = attribute( pChannelFormat, "about" );
				AddChannel( sName, sData, sURL, sDesc, bEnableByDefault, sVer, sImage, sImageWidth, sImageHeight );
				n++;
			}
		}
	}
	if( n==0 )
	{
		Error( "The channel list is empty." );
	}
}


function SaveProvidersMenu_OnCommand(i_pIUICommand)
{
	var URL = i_pIUICommand.CommandURL;
	var id = i_pIUICommand.ID;

	if( URL=="saveOPML" )
	{
		//  Display save dialog
		var FileDialogResult = App.SaveFileDialog (
			"Save As...",			//  title
			"*.opml",			//  filter
			"---garage---",		//  initial directory, deliberately unlikely
			"channels",			//  filename
			g_DeviceAccount,		//  account
			1,				//  filter index
			false				//  multi-select
			);

		//  If cancel button selected or no filename specified, just exit now		
		if( (GrooveDialogBoxResultCode_Cancel == FileDialogResult.Result) || (FileDialogResult.Data == "") ) return;

		saveOPML( FileDialogResult.Data + ".opml" );
	}

	if( URL=="saveGRV" )
	{
		//  Display save dialog
		var FileDialogResult = App.SaveFileDialog (
			"Save As...",			//  title
			"*.grv",			//  filter
			"---garage---",		//  initial directory, deliberately unlikely
			"newsspace",			//  filename
			g_DeviceAccount,		//  account
			1,				//  filter index
			false				//  multi-select
			);

		//  If cancel button selected or no filename specified, just exit now		
		if( (GrooveDialogBoxResultCode_Cancel == FileDialogResult.Result) || (FileDialogResult.Data == "") ) return;

		saveGRV( FileDialogResult.Data + ".opml" );
	}
}


function saveOPML( sFullPath )
{
	// Save the current list of channels to an OPML document.
	// - write an XML element
	// - serialise it

	var el;
	var sName = "untitled";

	// Create a temporary XML document;
	// and a root XML element
	var xmlTmp = g_StorageManager.CreateTemporaryXMLDocument();
	var elRoot = xmlTmp.CreateElement( "opml" );
	elRoot.SetAttribute( "version", "1.0" );
	xmlTmp.SetRootElement( elRoot );

	// Do the header
	// (minimal content here)
	var elHead = xmlTmp.CreateElement( "head" );

	el = xmlTmp.CreateElement( "title" );
	el.AppendContent( sName );
	elHead.AppendContentElement( el );

	elRoot.AppendContentElement( elHead );

	// Walk our stuff, creating corresponding elements in the temp doc.
	var elBody = xmlTmp.CreateElement( "body" );

	var pITransaction = g_Telespace.OpenTransaction(true);
	try
	{
		var pIRecordEnum = ChannelListRecordSetEngine.OpenRecordEnum();
		while (pIRecordEnum.HasMore())
		{
			var pIRecord = pIRecordEnum.OpenNext();

			var sName       = pIRecord.OpenField( "Name" );
			var sDesc       = pIRecord.OpenField( "Description" );
			var sURL        = pIRecord.OpenField( "SiteURL" );
			var sDataURL    = pIRecord.OpenField( "DataURL" );
			var sRSSVersion = pIRecord.OpenField( "RSSVersion" );
	
			var elChannel = xmlTmp.CreateElement( "outline" );
			elChannel.SetAttribute( "text", sName );
			elChannel.SetAttribute( "description", sDesc );
			elChannel.SetAttribute( "htmlUrl", sURL );
			elChannel.SetAttribute( "language", "unknown" );
			elChannel.SetAttribute( "title", sName );
			elChannel.SetAttribute( "type", "rss" );
			elChannel.SetAttribute( "version", sRSSVersion );
			elChannel.SetAttribute( "xmlUrl", sDataURL );
			elBody.AppendContentElement( elChannel );
		}
		pITransaction.EndRead();
	}
	catch (e)
	{
		pITransaction.Abort();
		Error( "Error reading the channel list: " + e.description );
		return;
	}

	elRoot.AppendContentElement( elBody );

	// Serialise the temporary document into the output file, via stream;
	var SerializeOptions = 
			GrooveSerializeOption_ConvertLFToCRLF + 
			GrooveSerializeOption_NoFragmentWrapper +
			GrooveSerializeOption_NoProlog +
			GrooveSerializeOption_NoLinks;

//			GrooveSerializeOption_WithFormatting + 

	// (Output the xml header by hand, otherwise we get the groove.net PI which confuses RadioUserland)
	var pIByteOutputStream = g_Misc.StreamFactory.CreateByteOutputStreamFromFile( sFullPath, false )
	var pICharOutputStream = pIByteOutputStream.OpenCharOutputStream( GrooveCharEncodingType_UTF8 );
	pICharOutputStream.WriteString( '<?xml version="1.0" encoding="UTF-8"?>' );
	pICharOutputStream.WriteChar( 13 );
	pICharOutputStream.WriteChar( 10 );
	pICharOutputStream.Flush();
	elRoot.SerializeToStream( pIByteOutputStream, GrooveSerializeType_XML, GrooveCharEncodingType_UTF8, SerializeOptions );

	// Close up.
	pIByteOutputStream.Close();
}


function saveGRV( sFullPath )
{
	// Save as a telespace template: not yet implemented
	// Two ways to do this:
	// - GRV has URL of an OCS or OPML file
	// - GRV has the list of channel URLs
	Error( "tbd" );
}


function attribute( pEl, sN )
{
	var pA = pEl.attributes;
	var pN = pA.getNamedItem( sN );
	if( !pN ) return "";
	return pN.nodeValue;
}

function element( pEl, sN )
{
	var pEls = pEl.getElementsByTagName( sN );
	if( pEls.length==0 ) return "";
	var pText = pEls.nextNode().firstChild;
	if( !pText ) return "";
	return pText.nodeValue;
}



//////////////////////////////////////////////////////////////////////////////
//   *********************  COMMAND BAR SUPPORT  ************************   //
//////////////////////////////////////////////////////////////////////////////

function UpdateCursorButtons()
{
	if (typeof UICommandContainer == "undefined" || UICommandContainer == null)
		return;
	if (UICommandContainer.UICommandExists(NEWSCLIENT_TOOL_PREVIOUS))
	{
		if (NewsItemsModelGlue.Collection.IsEmpty())
			UICommandContainer.OpenUICommand(NEWSCLIENT_TOOL_PREVIOUS).Enabled = false;
		else
			UICommandContainer.OpenUICommand(NEWSCLIENT_TOOL_PREVIOUS).Enabled = NewsItemsModelGlue.Cursor.CanMoveCursor(GrooveModelGlueCursorMove_PriorAny);
	}
	if (UICommandContainer.UICommandExists(NEWSCLIENT_TOOL_NEXT))
	{
		if (NewsItemsModelGlue.Collection.IsEmpty())
			UICommandContainer.OpenUICommand(NEWSCLIENT_TOOL_NEXT).Enabled = false;
		else
			UICommandContainer.OpenUICommand(NEWSCLIENT_TOOL_NEXT).Enabled = NewsItemsModelGlue.Cursor.CanMoveCursor(GrooveModelGlueCursorMove_NextAny);
	}
	if (UICommandContainer.UICommandExists(NEWSCLIENT_TOOL_PREVIOUS_UNREAD))
	{
		if (NewsItemsModelGlue.Collection.IsEmpty())
			UICommandContainer.OpenUICommand(NEWSCLIENT_TOOL_PREVIOUS_UNREAD).Enabled = false;
		else
			UICommandContainer.OpenUICommand(NEWSCLIENT_TOOL_PREVIOUS_UNREAD).Enabled = NewsItemsModelGlue.Cursor.CanMoveCursor(GrooveModelGlueCursorMove_PriorUnread);
	}
	if (UICommandContainer.UICommandExists(NEWSCLIENT_TOOL_NEXT_UNREAD))
	{
		if (NewsItemsModelGlue.Collection.IsEmpty())
			UICommandContainer.OpenUICommand(NEWSCLIENT_TOOL_NEXT_UNREAD).Enabled = false;
		else
			UICommandContainer.OpenUICommand(NEWSCLIENT_TOOL_NEXT_UNREAD).Enabled = NewsItemsModelGlue.Cursor.CanMoveCursor(GrooveModelGlueCursorMove_NextUnread);
	}
}

// ----------------------------------------------------------------------------
// IGrooveUICommandContainerSink implementation
// ----------------------------------------------------------------------------

function UICommandContainerOnCommand(i_UICommand)
{
	if (typeof UICommandContainer == "undefined" && UICommandContainer != null)
		return;

	var CommandURL = i_UICommand.CommandURL;
	if (CommandURL == NEWSCLIENT_TOOL_COPY_AS_LINK)
		CopyAsLink();
	else if (CommandURL == NEWSCLIENT_TOOL_NEXT)
	{
		NavigateToDocument(GrooveModelGlueCursorMove_NextAny);
	}
	else if (CommandURL == NEWSCLIENT_TOOL_PREVIOUS)
	{
		NavigateToDocument(GrooveModelGlueCursorMove_PriorAny);
	}
	else if (CommandURL == NEWSCLIENT_TOOL_NEXT_UNREAD)
	{
		NavigateToDocument(GrooveModelGlueCursorMove_NextUnread);
	}
	else if (CommandURL == NEWSCLIENT_TOOL_PREVIOUS_UNREAD)
	{
		NavigateToDocument(GrooveModelGlueCursorMove_PriorUnread);
	}
	else if (CommandURL == NEWSCLIENT_TOOL_MARK_ALL_UNREAD)
		MarkAllRecordsRead( NewsItemsRecordSetEngine, false );
	else if (CommandURL == NEWSCLIENT_TOOL_MARK_ALL_READ)
		MarkAllRecordsRead( NewsItemsRecordSetEngine, true );
	else if (CommandURL == NEWSCLIENT_TOOL_MARK_SELECTED_UNREAD)
	{
		if( g_CurrentItemRecordID > 0 ) MarkRecordRead( NewsItemsRecordSetEngine, g_CurrentItemRecordID, false );
	}
	else if (CommandURL == NEWSCLIENT_TOOL_MARK_SELECTED_READ)
	{
		if( g_CurrentItemRecordID > 0 ) MarkRecordRead( NewsItemsRecordSetEngine, g_CurrentItemRecordID, true );
	}
}


function NavigateToDocument(i_Direction)
{
	var pITransaction = g_Telespace.OpenTransaction(false);
	try
	{
		g_WindowManager.ShowWaitCursor();
		var b = NewsItemsModelGlue.Cursor.MoveCursorToRecord( g_CurrentItemRecordID );
		if (b == false)
		{
			pITransaction.Abort();
			return;
		}
		NewsItemsDataViewer.SelectSingleRow( g_CurrentItemRecordID );
		NewsItemsModelGlue.Cursor.MoveCursor(i_Direction);
		var RecordID = NewsItemsModelGlue.Cursor.GetCurrentRecordID();
		NewsItemsDataViewer.SelectSingleRow(RecordID);
		g_CurrentItemRecordID = RecordID;
		UpdateCursorButtons();
		ShowLinkedNewsItem( RecordID );
		g_WindowManager.ShowWaitCursor(false);
		pITransaction.Commit();
	}
	catch(e)
	{
		pITransaction.Abort();
	}
}


function UICommandContainerOnUpdateCommandState(i_UICommand)
{
	if ((typeof UICommandContainer == "undefined" && UICommandContainer != null)|| bCommandsShown == false)
		return;

	var CommandURL = i_UICommand.CommandURL;

	if (CommandURL == NEWSCLIENT_TOOL_COPY_AS_LINK)
	{
		if (NewsItemsDataViewer.GetIDOfFocusRow() != -1)
			i_UICommand.Enabled = true;
		else
			i_UICommand.Enabled = false;
	}
	else if (CommandURL == NEWSCLIENT_TOOL_UNREAD_MENU)
	{
		if (NewsItemsModelGlue.Collection.IsEmpty())
			i_UICommand.Enabled = false;
		else
			i_UICommand.Enabled = true;
	}
	UpdateCursorButtons();
}


function UICommandContainerOnUpdateContainerState(i_pContainer)
{
	// Nothing to do
}

function ShowUICommands(i_State)
{
	bCommandsShown = false;
	if (typeof UICommandContainer == "undefined") return;
	UICommandContainer.RemoveAllUICommands();

	var pCommand;
	var ImagesURL = CreateURLFromSchemeAndPath("grooveFile", "ToolData\\groove.net\\Discussion\\DiscussionToolIconImages.jpg");
	var ImagesMaskURL = CreateURLFromSchemeAndPath("grooveFile", "ToolData\\groove.net\\Discussion\\DiscussionToolIconImagesMask.bmp");
	var Position = UICommandContainer.GetNumberOfUICommands();
	var Offset = 0;
	var Width = 16;
	var Height = 16;			

	// Clipboard
			
	ImagePosition = 6;
	pCommand = UICommandContainer.InsertUICommand(NEWSCLIENT_TOOL_COPY_AS_LINK, Position++);
	pCommand.Tooltip = NEWSCLIENT_TOOL_TOOLTIP_COPY_AS_LINK + " (CTRL+L)";
	pCommand.Mnemonic = "CTRL+L";
	Offset = Width * ImagePosition;
	pCommand.SetImage(ImagesURL, ImagesMaskURL, Offset, Width, Height);

	// Navigation
	UICommandContainer.InsertSeparator(NEWSCLIENT_TOOL_SEPARATOR, Position++);
				
	ImagePosition = 8;
	pCommand = UICommandContainer.InsertUICommand(NEWSCLIENT_TOOL_PREVIOUS_UNREAD, Position++);
	pCommand.Tooltip = NEWSCLIENT_TOOL_TOOLTIP_PREVIOUS_UNREAD;
	Offset = Width * ImagePosition;
	pCommand.SetImage(ImagesURL, ImagesMaskURL, Offset, Width, Height);

	ImagePosition = 9;
	pCommand = UICommandContainer.InsertUICommand(NEWSCLIENT_TOOL_NEXT_UNREAD, Position++);
	pCommand.Tooltip = NEWSCLIENT_TOOL_TOOLTIP_NEXT_UNREAD;
	Offset = Width * ImagePosition;
	pCommand.SetImage(ImagesURL, ImagesMaskURL, Offset, Width, Height);
				
	ImagePosition = 18;
	pCommandContainer = UICommandContainer.InsertUICommandContainer(NEWSCLIENT_TOOL_UNREAD_MENU, Position++);
	pCommandContainer.UICommand.Tooltip = NEWSCLIENT_TOOL_TOOLTIP_UNREAD_MENU;
	Offset = Width * ImagePosition;
	pCommandContainer.UICommand.SetImage(ImagesURL, ImagesMaskURL, Offset, Width, Height);
					
	pCommand = pCommandContainer.UICommandContainer.InsertUICommand(NEWSCLIENT_TOOL_MARK_ALL_READ, 0);
	pCommand.Label = "Mark All Read";

	pCommand = pCommandContainer.UICommandContainer.InsertUICommand(NEWSCLIENT_TOOL_MARK_ALL_UNREAD, 1);
	pCommand.Label = "Mark All Unread";

	pCommand = pCommandContainer.UICommandContainer.InsertUICommand(NEWSCLIENT_TOOL_MARK_SELECTED_READ, 2);
	pCommand.Label = "Mark Selected Read";

	pCommand = pCommandContainer.UICommandContainer.InsertUICommand(NEWSCLIENT_TOOL_MARK_SELECTED_UNREAD, 3);
	pCommand.Label = "Mark Selected Unread";

	bCommandsShown = true;
	UpdateCursorButtons();
}

function HideUICommands()
{
	if (typeof UICommandContainer == "undefined") return;
	if (bCommandsShown)
	{
		bCommandsShown = false;
		UICommandContainer.RemoveAllUICommands();
	}
}

function CopyAsLink()
{
	var sTitle = "news";
	if( g_CurrentItemTitle ) sTitle = g_CurrentItemTitle;
	CopyAsLinkToClipboard( g_CurrentItemURL, sTitle );
	CopyTextToClipboard( g_CurrentItemURL );
}


//////////////////////////////////////////////////////////////////////////////
//  *********************  END COMMAND BAR SUPPORT ************************ //
//////////////////////////////////////////////////////////////////////////////


function Timer_OnTimer( sName )
{
	// Timer ticks occasionally.
	g_WindowManager.ShowWaitCursor();

	// Pick the (active) channel we've least recently visited, and fetch it.
	// Channels are stampted with a "LastPoll" date,
	// so finding the least-recently-polled is fairly easy,
	// but this should ideally be striped modulo online users
	// so we don't duplicate fetching at every client node.

	var bAnyNeverPolled = false;
	var nChannels = 0;
	var nOldest = g_Intl.CreateDate().RawDateTime;
	var sChannelUNID = "";
	var sChannelName = "";
	var sURL = "";
	var pITransaction = g_Telespace.OpenTransaction(true);
	try
	{
		var RecordIDEnum = ChannelListRecordSetEngine.OpenRecordIDEnum();
		while( RecordIDEnum.HasMore() )
		{
			var nRecordID = RecordIDEnum.OpenNext();
			if( ChannelListModelGlue.Cursor.HasRecord(nRecordID) )
			{
				var pIRecord = ChannelListModelGlue.OpenRecord(nRecordID);
				var nPolled = pIRecord.OpenField( "LastPoll" );
				var bActive = pIRecord.OpenField( "IsActive" );
				if( bActive )
				{
					if( pIRecord.OpenField( "NPolls" )==0 ) bAnyNeverPolled = true;
					nChannels++;
				}
				if( bActive && ( nPolled < nOldest ) )
				{
					nOldest = nPolled;
					sChannelUNID = pIRecord.OpenFieldAsString("UNID");
					sChannelName = pIRecord.OpenFieldAsString("Name");
					sURL = pIRecord.OpenFieldAsString("DataURL");
				}
			}
		}
		pITransaction.EndRead();
	}
	catch( e )
	{
		pITransaction.Abort();
		Error( "Error in Timer_OnTimer: " + e.description );
	}

	// Having found the oldest, poll it
	if( sChannelUNID=="" ) return;
	PollChannel( sURL, sChannelUNID + "|" + sChannelName );

	var nInterval = 1000;
	if( !bAnyNeverPolled )
	{
		// Adjust the timer interval to ensure that, on average, we'll complete the channel cycle every ~30 minutes.
		// Therefore interval = 60 / nChannels * nOnlineMembers
		var nOnlineMembers = g_MembersAwareness.GetActiveTelespaceMemberCount();
		nInterval = 1200000 / (nChannels + 1) * (nOnlineMembers + 1);
		Debug( nChannels + " channels, " + nOnlineMembers + " online members, " + (nInterval/1000) + "s polling interval" );
	}
	g_WindowManager.ShowWaitCursor( false );
	Timer.Interval = nInterval;
}

function PollChannel( sURL, sSrcHandle )
{
	Debug( "PollChannel " + sSrcHandle );

	// sSrcHandle is the channel UNID + "|" + name
	var n = sSrcHandle.indexOf("|");
	var sChannelUNID = sSrcHandle.substr(0,n);
	var sChannelName = sSrcHandle.substr(n+1);

	var pITransaction = g_Telespace.OpenTransaction(false);
	try
	{
		// Get the channel's record,
		// updating it's last-polled timestamp
		var RecordID = GetChannelIDByUNID( sChannelUNID );
		if( RecordID == -1 )
		{
			Debug( "Nonexistent channel " + sSrcHandle );
			pITransaction.Abort();
			return;
		}
		if( !ChannelListModelGlue.Cursor.HasRecord(RecordID) )
		{
			Error( "Can't find the channel record for " + sSrcHandle );
			pITransaction.Abort();
			return;
		}
		var pIRecord = ChannelListModelGlue.OpenRecord(RecordID);
		var nS = pIRecord.OpenField( "NSuccesses" );
		var nP = pIRecord.OpenField( "NPolls" ) + 1;
		pIRecord.SetField( "LastPoll", g_Intl.CreateDate().RawDateTime )
		pIRecord.SetFieldAsDouble( "NPolls", nP )
		pIRecord.SetField( "Reliability", nS + "/" + nP );

		pITransaction.Commit();
	}
	catch( e )
	{
		pITransaction.Abort();
		Error( "Error in PollChannel: " + e.description );
	}
	var pChannel = g_RSSClient.GetNewRSSSource( sURL, sSrcHandle );
	if( !pChannel )
	{
		Error( "PollChannel failed for " + sSrcHandle );
		return;
	}
	ConnectObject( pChannel, "RSSClient_" );
}


function PollActiveNow( RecordID )
{
	var pITransaction = g_Telespace.OpenTransaction(false);
	try
	{
		if( !ChannelListRecordSetEngine.HasRecord(RecordID) )
		{
			pITransaction.Abort();
			return;
		}

		var pIRecord = ChannelListRecordSetEngine.OpenRecord(RecordID);
		var bActive = pIRecord.OpenField("IsActive");
		if( !bActive )
		{
			pITransaction.Abort();
			return;
		}

		var sChannelUNID = pIRecord.OpenFieldAsString("UNID");
		var sChannelName = pIRecord.OpenFieldAsString("Name");
		var sURL = pIRecord.OpenFieldAsString("DataURL");
		PollChannel( sURL, sChannelUNID + "|" + sChannelName );
		pITransaction.Commit();
	}
	catch( e )
	{
		Error( "Error in PollActiveNow: " + e.description );
		pITransaction.Abort();
	}
}

function RemoveNews( RecordID, bOnlyIfInactive )
{
	// Functionality chg: don't remove news from inactive channels
	if( bOnlyIfInactive ) return;

	var pITransaction = g_Telespace.OpenTransaction(false);
	try
	{
		if( !ChannelListRecordSetEngine.HasRecord(RecordID) )
		{
			pITransaction.Abort();
			return;
		}

		var pIRecord = ChannelListRecordSetEngine.OpenRecord(RecordID);
		if( bOnlyIfInactive )
		{
			var bActive = pIRecord.OpenField("IsActive");
			if( bActive )
			{
				pITransaction.Abort();
				return;
			}
		}

		var sUNID = pIRecord.OpenFieldAsString("UNID");

		// Find any records for this channel (the slow way! .Find() is unreliable)
		var nMatches = 0;

		var pNewsIDEnum = g_Misc.EnumFactory.CreateDoubleEnum();
		var RecordIDEnum = NewsItemsRecordSetEngine.OpenRecordIDEnum();
		while( RecordIDEnum.HasMore() )
		{
			var nRecordID = RecordIDEnum.OpenNext();
			if( NewsItemsModelGlue.Cursor.HasRecord(nRecordID) )
			{
				var pIRecord = NewsItemsModelGlue.OpenRecord(nRecordID);
				var sChannelUNID = pIRecord.OpenField( "ChannelUNID" );
				if( sUNID == sChannelUNID )
				{
					pNewsIDEnum.DoubleEnumCreate.Add( nRecordID );
					nMatches++;
				}
			}
		}

		if( nMatches == 0 )
		{
			// We had no news from this channel anyway.  Nothing to do.
			pITransaction.Abort();
			return;
		}

		// Delete all the old news.
		NewsItemsModelGlue.DeleteRecords( pNewsIDEnum );
		pITransaction.Commit();
	}
	catch( e )
	{
		Error( "Error deleting old news: " + e.description );
		pITransaction.Abort();
	}
}


// ----------------------------------
// - NewsClient DLL Event Listeners	-
// ----------------------------------

function RSSClient_docReady( pChan )
{
	// Data has arrived from a channel.
	g_WindowManager.ShowWaitCursor();

	// We're done listening to this channel for now
	var pChannel = pChan;
	var sSrcHandle = pChannel.connectKey;
	DisconnectObject( pChan );

	// sSrcHandle is the channel UNID + "|" + name
	var n = sSrcHandle.indexOf("|");
	var sChannelUNID = sSrcHandle.substr(0,n);
	var sChannelName = sSrcHandle.substr(n+1);

	// Everything here is wrapped inside a transaction, so it'll unwind en bloc
	var pITransaction = g_Telespace.OpenTransaction(false);
	try
	{
		// Get the channel's record,
		// updating it's last-received timestamp
		var RecordID = GetChannelIDByUNID( sChannelUNID );
		if( RecordID == -1 )
		{
			// Results from a nonexistent channel!  It's possible...
			g_WindowManager.ShowWaitCursor( false );
			Debug( "Received news item from nonexistent channel " + sSrcHandle );
			pITransaction.Abort();
			return;
		}
		if( !ChannelListModelGlue.Cursor.HasRecord(RecordID) )
		{
			g_WindowManager.ShowWaitCursor( false );
			Error( "Can't find the channel record for news from " + sSrcHandle );
			pITransaction.Abort();
			return;
		}
		var pIRecord = ChannelListModelGlue.OpenRecord(RecordID);
		var nS = pIRecord.OpenField( "NSuccesses" ) + 1;
		var nP = pIRecord.OpenField( "NPolls" );
		pIRecord.SetField( "LastSuccess", g_Intl.CreateDate().RawDateTime )
		pIRecord.SetFieldAsDouble( "NSuccesses", nS )
		pIRecord.SetField( "Reliability", nS + "/" + nP );

		// While we're here, make sure that the channel's metadata is up-to-date!
		var pCh = pChannel.getChannel();
		var s;
		var f;
		f = "Name";        s = pCh.getTitle();       if( s != pIRecord.OpenField( f ) ) pIRecord.SetField( f, s );
		f = "SiteURL";     s = pCh.getLink();        if( s != pIRecord.OpenField( f ) ) pIRecord.SetField( f, s );
		f = "Description"; s = pCh.getDesc();        if( s != pIRecord.OpenField( f ) ) pIRecord.SetField( f, s );
		f = "ImageURL";    s = pCh.getImageURL();    if( s != pIRecord.OpenField( f ) ) pIRecord.SetField( f, s );
		f = "ImageHeight"; s = pCh.getImageHeight(); if( s != pIRecord.OpenField( f ) ) pIRecord.SetField( f, s );
		f = "ImageWidth";  s = pCh.getImageWidth();  if( s != pIRecord.OpenField( f ) ) pIRecord.SetField( f, s );

		// Now add each of the new news items to our list
		var newKey;
		var rssItem;
		var numItems = pChannel.getLength();
		var nNew = 0;
		for (var i=0;i<numItems ;i++ )
		{
			// Add this item to the database, if we didn't already have it
			rssItem = pChannel.getItem( i );

			var bSyntheticTitle = false;
			var sTitle = rssItem.getTitle();
			var sDesc  = rssItem.getDesc();
			var sLink  = rssItem.getLink();

			// Where the news item doesn't have a title, try using a few characters from the description
			if( sTitle=="" )
				if( sDesc != "" )
				{
					// Strip any embedded HTML encoding (anglebrackets and anything between them)
					var r = /<([^<>]*)>/g;
					sTitle = sDesc.replace( r, "" );
					// Replace any HTML entities
					sTitle = sTitle.replace( /&lt;/g, "<" );
					sTitle = sTitle.replace( /&gt;/g, ">" );
					sTitle = sTitle.replace( /&nbsp;/g, " " );
					sTitle = sTitle.replace( /&quot;/g, '"' );
					sTitle = sTitle.replace( /&apos;/g, "'" );
					sTitle = sTitle.replace( /&amp;/g, "&" );
					// Trim at the first fullstop, or spaces...
					var n = sTitle.indexOf( ".", 30 );
					if( n<=0 ) n = sTitle.indexOf( " ", 30 );
					if( n>0 ) sTitle = sTitle.substr(0,n) + "...";
					bSyntheticTitle = true;
				}

			// NB: Additional news source information is provided by some Moreover feeds
			if( rssItem.getSource() )
				if( rssItem.getSource() != "" )
					sTitle += " (" + rssItem.getSource() + ")";

			if( AddNewRecord( sChannelName, sChannelUNID, sTitle, sLink, sDesc, bSyntheticTitle ) )
				nNew++;
		}
		if( nNew > 0 )
			Info( nNew + " new news items from " + sChannelName );
		pITransaction.Commit();
	}
	catch (e)
	{
		pITransaction.Abort();
		Error( "Error in docReady: " + e.description );
	}
	g_WindowManager.ShowWaitCursor( false );
}


function RSSClient_docNotLoaded( pCh, sError )
{
	// We're done listening to this channel for now
	var pChannel = pCh;
	var sSrcHandle = pCh.connectKey;
	if( pChannel )
	{
		DisconnectObject( pCh );
	}

	// (Fail silently... users don't want to see this!)
	// return;

	// sSrcHandle is the channel UNID + "|" + name
	var n = sSrcHandle.indexOf("|");
	var sChannelUNID = sSrcHandle.substr(0,n);
	var sChannelName = sSrcHandle.substr(n+1);

	// Everything here is wrapped inside a transaction, so it'll unwind en bloc
	var pITransaction = g_Telespace.OpenTransaction(false);
	try
	{
		// Get the channel's record,
		var RecordID = GetChannelIDByUNID( sChannelUNID );
		if( RecordID == -1 )
		{
			pITransaction.Abort();
			return;
		}
		if( !ChannelListModelGlue.Cursor.HasRecord(RecordID) )
		{
			pITransaction.Abort();
			return;
		}
		var pIRecord = ChannelListModelGlue.OpenRecord(RecordID);
		var sName = pIRecord.OpenField( "Name" );

//		Info( "Error reading channel '" + sName + "': " + sError );

		pITransaction.Abort();
	}
	catch (e)
	{
		pITransaction.Abort();
		Error( "Error in docNotLoaded: " + e.description );
	}
}


/**
  * ------------------------------
  * Data model listeners
  * ------------------------------
  */


function ChannelListRecordSetEngine_OnRecordSetChanged( i_pIRecordSetEngine, i_RecordSetChangeType, i_pIRecordIDEnum )
{
}

/**
  * Data model Listener for NewsItemRecordset events
  * synchronises the recordset with the TreeView
  */

function NewsItemsRecordSetEngine_OnRecordSetChanged( i_pINewsItemsRecordSetEngine, i_RecordSetChangeType, i_pIRecordIDEnum )
{
	if( !UI ) return;

	var pITransaction = g_Telespace.OpenTransaction(true);
	try
	{
		// Enumerate all record ids
		while (i_pIRecordIDEnum.HasMore())
		{
			var RecordID = i_pIRecordIDEnum.OpenNext();
			if (GrooveRecordSetChangeType_Added == i_RecordSetChangeType)
			{
				TreeViewAdd( RecordID );
			}
			else if (GrooveRecordSetChangeType_Removed == i_RecordSetChangeType)
			{
				TreeViewRemove( RecordID );
			}
		}
		// Commit the transaction 
		pITransaction.EndRead();
	}
	catch (e)
	{
		pITransaction.Abort();
		Error( "Error in NewsItemsRecordSetEngine_OnRecordSetChanged: " + e.description );
	}
}


// ----------------------
// - Generic Functions	-
// ----------------------

function SetDocumentImage(i_ID)
{
	TreeView.SetItemImage(i_ID, g_DocumentImage, g_DocumentImageSelected);
}		
function SetFolderImage(i_ID)
{
	TreeView.SetItemImage(i_ID, g_FolderImage, g_FolderImageSelected);
}
//	function SetDocumentImageUnreadNoComment(i_ID)
//	{
//		TreeView.SetItemImage(i_ID, g_Document_Closed_Unread_NoComment, g_Document_Open_Unread_NoComment);
//	}	
//	function SetDocumentImageReadNoComment(i_ID)
//	{
//		TreeView.SetItemImage(i_ID, g_Document_Closed_Read_NoComment, g_Document_Open_Read_NoComment);
//	}	


//  ---------------------------------------------------
//  TreeView Initialisation
//  ---------------------------------------------------
function InitialiseTree()
{
	// Set up the treeview images
	g_DocumentImage = TreeView.ImageList.AddImageByResourceFileIndex("shell32.dll", 70);
	g_DocumentImageSelected = TreeView.ImageList.AddImageByResourceFileIndex("shell32.dll", 70);
	g_FolderImage = TreeView.ImageList.AddImageByResourceFileIndex("shell32.dll",3);
	g_FolderImageSelected = TreeView.ImageList.AddImageByResourceFileIndex("shell32.dll",4);						
//	g_Document_Open_Unread_NoComment= TreeView.ImageList.AddImageByResourceFileIndex("CabezalNewsClientLibrary.dll",2);
//	g_Document_Closed_Unread_NoComment= TreeView.ImageList.AddImageByResourceFileIndex("CabezalNewsClientLibrary.dll",1);
//	g_Document_Open_Read_NoComment= TreeView.ImageList.AddImageByResourceFileIndex("CabezalNewsClientLibrary.dll",4);
//	g_Document_Closed_Read_NoComment= TreeView.ImageList.AddImageByResourceFileIndex("CabezalNewsClientLibrary.dll",3);

	if( !TreeView.DoesItemExist( "RootKey" ) )
	{
		// Make a root node (tbd: name after this tool!)
		TreeView.InsertItem( "News", "RootKey", "", GrooveTreeCtrlInsertOrder_Root, g_FolderImage );
		SetFolderImage("RootKey");
		TreeView.SetItemData( "RootKey", "Root" );
	}

	var pITransaction = g_Telespace.OpenTransaction(true);
	try
	{
		var pIRecordEnum = NewsItemsRecordSetEngine.OpenRecordEnum();
		while (pIRecordEnum.HasMore())
		{
			var pIRecord = pIRecordEnum.OpenNext();
			var RecordID = pIRecord.RecordID;
			TreeViewAdd( RecordID );
		}
		pITransaction.EndRead();
	}
	catch (e)
	{
		pITransaction.Abort();
		Error( "Error in InitialiseTree: " + e.description );
	}
	if( TreeView.ItemHasChildren( "RootKey" ) )
		TreeView.ExpandItem("RootKey", GrooveTreeCtrlExpandOrder_Expand);	
}

function TerminateTree()
{
	TreeView.DeleteAllItems();
}

function TreeViewAdd( RecordID )	// must be called from within a transaction block
{
	if( !NewsItemsRecordSetEngine.HasRecord(RecordID) )
		return;

	var pIRecord = NewsItemsRecordSetEngine.OpenRecord(RecordID);

	var sChannelUNID = pIRecord.OpenFieldAsString("ChannelUNID");
	var sChannelName = pIRecord.OpenFieldAsString("Channel");
	var sKey = pIRecord.OpenFieldAsString("UNID");
	var sTitle = pIRecord.OpenFieldAsString("Title");

	var nCreated = pIRecord.OpenFieldAsDouble("_Created");
	var DateFormat = g_Intl.CreateDateFormatForDateTime(3, 3, g_Null);
	var DateObj = g_Intl.CreateDateFromRawDateTime(nCreated);
	var sDate = DateFormat.Format(DateObj, "", g_Null);

	// Check a folder exists for the channel
	if( !TreeView.DoesItemExist( sChannelUNID ))
	{
		TreeView.InsertItem( sChannelName, sChannelUNID, "RootKey", GrooveTreeCtrlInsertOrder_Sort, g_FolderImage );
		SetFolderImage( sChannelUNID );
		TreeView.SetItemData( sChannelUNID, sChannelUNID );
	}

	// Create a new treeview document with the record Title as the title
	if( !TreeView.DoesItemExist( sKey ))
	{
		TreeView.InsertItem( "(" + sDate + ") " + sTitle, sKey, sChannelUNID, GrooveTreeCtrlInsertOrder_First, g_DocumentImage );
		SetDocumentImage( sKey );
		TreeView.SetItemData( sKey, RecordID );
	}
}


function TreeViewRemove( RecordID )	// must be called from within a transaction block
{
	if( !NewsItemsRecordSetEngine.HasRecord(RecordID) )
		return;

	var pIRecord = NewsItemsRecordSetEngine.OpenRecord(RecordID);

	var sKey = pIRecord.OpenFieldAsString("UNID");

	// Delete treeview document
	if( TreeView.DoesItemExist( sKey ))
		try
		{
			TreeView.DeleteItem( sKey );
		}
		catch(e)
		{}
}


/**
  * ---------------------------------------------------
  * Recordset Actions
  * ---------------------------------------------------
  */

function AddNewRecord(sChannel, sChannelUNID, sItemTitle, uItemLink, sItemDescription, bSyntheticTitle)
{
	// return true if we didn't have this news item already
	var bNew = false;
	try
	{
		//Calculate a UniqueCheckSum for this item
		var sUNID;
		var md5Instance = new MD5();
		md5Instance.init();

		//Check Sum is made up of: ChannelUNID, Item Title, Item Link and first 30 chars of Item Description, added in that order
		md5Instance.update( sChannelUNID );
		md5Instance.update( sItemTitle );
		md5Instance.update( uItemLink );
		md5Instance.update( sItemDescription);
		md5Instance.finish();
		sUNID = md5Instance.getString();

		// Does a record matching this content already exist? (the slow way! .Find() is unreliable)
		var nMatches = 0;
		var RecordIDEnum = NewsItemsRecordSetEngine.OpenRecordIDEnum();
		while( RecordIDEnum.HasMore() )
		{
			var nRecordID = RecordIDEnum.OpenNext();
			if( NewsItemsModelGlue.Cursor.HasRecord(nRecordID) )
			{
				var pIRecord = NewsItemsModelGlue.OpenRecord(nRecordID);
				var sTmpUNID = pIRecord.OpenField( "UNID" );
				if( sUNID == sTmpUNID )
				{
					nMatches++;
					break;
				}
			}
		}

		//if it doesn't then create it
		if (nMatches==0)
		{
			// Create a record to give to add to the NewsItemsRecordSetEngine
			var pIRecord = NewsItemsModelGlue.CreateRecord("urn:cabezal.com:NewsClientItemRecord");

			// Set the text field in the record to be the edit text
			pIRecord.SetField("UNID", sUNID);
			pIRecord.SetField("ok", "1");
			pIRecord.SetField("Channel",sChannel);
			pIRecord.SetField("ChannelUNID",sChannelUNID);
			pIRecord.SetField("Title",sItemTitle);
			pIRecord.SetField("Link",uItemLink);
			pIRecord.SetField("Description",sItemDescription);
			pIRecord.SetField("Synth",bSyntheticTitle);

			// Debug("Channel:"+sChannel+" url:"+sChannelUNID+" Title:"+sItemTitle+" Link:"+uItemLink, "Mid term Scaffolding - add new record");

			// Save the new record
			NewsItemsModelGlue.AddRecord(pIRecord);
			MarkRecordRead( NewsItemsRecordSetEngine, pIRecord.RecordID, false );
			bNew = true;
		}
	}
	catch (e)
	{
		Error( "Error in Add New Record: " + e.description );
	}
	return bNew;
}


function RemoveRecord( sUNID )
{
	//We don't need to remove news items at this time.  May start archiving after n days.

}




/**
  * ---------------------------------------------------
  * View listeners
  * ---------------------------------------------------
  */


/**
  * View listener for TreeView
  */

function TreeView_OnTreeCtrlSelectionChangeEnd(i_Name, i_IDItemOld, i_IDItemNew, i_Trigger)
{
	//Ok which node did we change to
	var sExpectedRecordID;
	sExpectedRecordID = TreeView.GetItemData(i_IDItemNew);
	if( !isNaN(sExpectedRecordID) )	// ignore "channel", only react to "items"
	{
		ShowLinkedNewsItem(sExpectedRecordID);
	}
}

/**
  * View listener for NewsItemsDataViewer
  */

function NewsItemsDataViewer_OnDataViewerRecordSelectionChanged( i_DataViewerName, i_RecordID )
{
	var RecordID = NewsItemsDataViewer.GetIDOfFocusRow();
	ShowLinkedNewsItem( RecordID )
}

function ShowLinkedNewsItem( RecordID )
{
	//  If no entry in the list has been selected, just exit
	if (-1 == RecordID)
	{
		Debug( "ShowLinkedNewsItem: no recordID" );
		return;
	}

	g_CurrentItemRecordID = 0;
	g_CurrentItemUNID = null;
	g_CurrentItemURL = null;
	g_CurrentItemTitle = null;

	var bDone = false;
	var pITransaction = g_Telespace.OpenTransaction(true);
	try
	{
		//  Get the record
		if( !NewsItemsModelGlue.Cursor.HasRecord(RecordID) )
		{
			Debug( "ShowLinkedNewsItem: no record " + RecordID );
			WebBrowserView.Navigate( "about:blank" );
		}
		else
		{
			var pIRecord = NewsItemsModelGlue.OpenRecord(RecordID);

			// Remember which document we're looking at.
			g_CurrentItemRecordID = RecordID;
			g_CurrentItemUNID = pIRecord.OpenField( "UNID" );
			g_CurrentItemTitle = pIRecord.OpenField( "Title" );

			// Lookup channel information for this document
			var sChannelUNID = pIRecord.OpenField( "ChannelUNID" );
			var sChannelName = "";
			var sChannelDesc = "";
			var sChannelLink = "";
			var sChannelImg = "";
			var sChannelImgWidth = "88";
			var sChannelImgHeight = "31";
			var pChannel = GetChannelRecordByUNID( sChannelUNID );
			if( pChannel )
			{
				sChannelName      = pChannel.OpenField( "Name" );
				sChannelDesc      = pChannel.OpenField( "Description" );
				sChannelLink      = pChannel.OpenField( "SiteURL" );
				if( pChannel.HasField( "ImageURL" ) ) sChannelImg       = pChannel.OpenField( "ImageURL" );
				if( pChannel.HasField( "ImageURL" ) ) sChannelImgWidth  = pChannel.OpenField( "ImageWidth" );
				if( pChannel.HasField( "ImageURL" ) ) sChannelImgHeight = pChannel.OpenField( "ImageHeight" );
			}
			var sTitle = pIRecord.OpenField( "Title" );
			var sURL = pIRecord.OpenField( "Link" );

			// Do we have a cached channel image? If so, use it.  If not, try to get it!
			if( sChannelImg != "" )
			{
				var sPath = g_FullPersistRootPath + "ToolData\\cabezal.com\\Tools\\NewsClient\\" + sChannelUNID;
				if( g_FileSystem.DoesFileExist( sPath ) )
					sChannelImg = "file:///" + sPath;
				else
					DownloadFile( sChannelImg, sPath );
			}

			// Did we make the title up ourselves?  If so, we may not need it now
			if( pIRecord.HasField("Synth") )
				if( pIRecord.OpenFieldAsBool("Synth") )
					if( sURL=="" )
						sTitle = "";

			var sLocalURL = "file:///" + g_FullPersistRootPath + "ToolData\\cabezal.com\\Tools\\NewsClient\\CabezalNewsClient.html";
			sLocalURL = sLocalURL + "?name=" + encodeURI( sTitle );
			sLocalURL = sLocalURL + "&desc=" + encodeURI( pIRecord.OpenField( "Description" ) );
			sLocalURL = sLocalURL + "&link=" + encodeURI( sURL );
			sLocalURL = sLocalURL + "&cimg=" + encodeURI( sChannelImg );
			sLocalURL = sLocalURL + "&cwid=" + encodeURI( sChannelImgWidth );
			sLocalURL = sLocalURL + "&chei=" + encodeURI( sChannelImgHeight );
			sLocalURL = sLocalURL + "&cnam=" + encodeURI( sChannelName );
			sLocalURL = sLocalURL + "&clnk=" + encodeURI( sChannelLink );
			sLocalURL = sLocalURL + "&chid=" + encodeURI( sChannelUNID );
			sLocalURL = sLocalURL + "&cdsc=" + encodeURI( sChannelDesc );

			sURL = sLocalURL;
			if( sURL.length > 2000 ) sURL = sURL.substr(0,2000) + "...";

			g_CurrentItemURL = sURL;
			// Succeeded.  Go there.
			if( g_CurrentWebURL != sURL ) WebBrowserView.Navigate( sURL );
			bDone = true;
		}
		pITransaction.EndRead();
	}
	catch (e)
	{
		Error( "Error in ShowLinkedNewsItem: " + e.description );
		pITransaction.Abort();
	}
	if( !bDone )
	{
		// There is no current document
		WebBrowserView.Navigate( "about:blank" );
	}
}


/**
  * View listener for the Web browser control
  */

function WebBrowserView_OnUserNavigateBegin( sURL, bIsTopLevel )
{
	NewsLogo.Loop = true;
	NewsLogo.Rewind();
	NewsLogo.Play();

	// Mark as read
	if( g_CurrentItemRecordID==0 ) return;
	MarkRecordRead( NewsItemsRecordSetEngine, g_CurrentItemRecordID, true );
	UpdateCursorButtons();
}

function WebBrowserView_OnUserNavigateEnd( sURL, bIsTopLevel )
{
	NewsLogo.Loop = false;

	// Check whether we know about this and should disable the "comments" button
	// Ignore non-toplevel navigation??

	if( sURL == g_CurrentItemURL )
	{
		BackButton.Enabled = false;
//		CommentsButton.Enabled = true;
	}
	else
	{
		BackButton.Enabled = true;
//		CommentsButton.Enabled = false;
	}

	if( g_CurrentItemURL == "about:blank" )
		CommentsButton.Enabled = false;
	else
		CommentsButton.Enabled = true;

	g_CurrentWebURL = sURL;
}

function BackButton_OnCommand(i_pIUICommand)
{
	WebBrowserView.GoBack();
}



					]]>
				</SCRIPT>


	<IMPLEMENTS LIBID="{1757BAF1-1632-11d5-80DD-0050DA1C04B5}" IID="{1757BAF7-1632-11d5-80DD-0050DA1C04B5}">
		<SCRIPT>
			<![CDATA[
/**
  * ---------------------------------------------------
  * IGrooveAggregatedObjectEntryStoreListener
  * ---------------------------------------------------
  */
function OnRoleChanged(i_ScopeURL, i_ObjectID, i_ChildType, i_RoleName, i_MemberContactURLOrParentRoleName, i_ChangeType)
{
	EnableDisableUI();
}
			]]>
		</SCRIPT>
	</IMPLEMENTS>


	<IMPLEMENTS LIBID="{4253A641-5FA3-11D2-98C2-0080C7E30BA4}" IID="{51BF81E1-6DE7-11D2-9461-0080C7DE32C6}">
		<SCRIPT>
			<![CDATA[
/**
  * ---------------------------------------------------
  * IGrooveURLNavigationHandler
  * ---------------------------------------------------
  */
function OnNavigate(i_pIURLNavigator, i_URL, i_bAddToHistory)
{
	var pURL = GROOVE_GLOBAL_MISC_POINTER.OpenURI(i_URL);
	if (pURL.DoesQueryPartExist("RecordID"))
	{
		var RecordID = pURL.OpenQueryPart("RecordID");
		var RecordIDEnum = NewsItemsModelGlue.CreateRecordIDEnum().DoubleEnumCreate;
		RecordIDEnum.Add( RecordID );
		NewsItemsDataViewer.SetRowSelection(RecordIDEnum, true);
		NewsItemsModelGlue.Cursor.MoveCursorToRecord( NewsItemsDataViewer.GetIDOfFocusRow() );
		UpdateCursorButtons();
		ShowLinkedNewsItem( RecordID );
	}
	var Telespace = PropertyList.OpenProperty(PROPERTY_TELESPACE);
	var Tool = PropertyList.OpenProperty(PROPERTY_TOOL);
	var Name = Tool.DisplayName;
	i_pIURLNavigator.SetCurrentURL(i_URL, Telespace.DisplayName + " - " + Name, Name, i_bAddToHistory);
}
			]]>
		</SCRIPT>
	</IMPLEMENTS>

			</g:Component>


		<g:Component Name="DownloadGlue">
			<g:ComponentResource URL="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveCommonComponents_DLL&amp;Version=0&amp;Factory=ScriptHost2" FingerprintID="Groove"/>
				
			<g:ComponentConnections/>
			<g:ExternalObjectConnections/>
			<g:PropertyList Version="1"/>
				
			<SCRIPT SRC="http://components.groove.net/Groove/Components/Root.osd?Package=net.groove.Groove.ToolComponents.GrooveGlobalHelperFunctions_GSL&amp;Version=0,1&amp;Factory=Open" FingerprintID="Groove"/>
			<SCRIPT>
				<![CDATA[
/**
  * Download handler.
  * - Ask to download a file (always asynchronously)
  * - Downloads in chunks up to 5kb, using the OnIdle handler to initiate
  * - Be notified when download completes
  * - Be notified when download fails
  * - Query status of downloads
  *
  * Events:
  * DownloadQueued( sURL, sDestPath )
  * DownloadComplete( sURL, sDestPath )
  * DownloadFailed( sURL, sErrorDesc )
  */

var g_SystemServices;
var g_Transport;
var g_Misc = GROOVE_GLOBAL_MISC_POINTER;
var g_FileSystem;
var g_IdleManagerCookie;
// var g_RSSClient = GrooveScriptFunctions.CreateNewObject("CabezalNewsClientLibrary.cNewsClient");


var aDownloadDests = new Array();
var aDownloadHTTPClients = new Array();
var aDownloadInStreams = new Array();
var aDownloadOutStreams = new Array();

var nQueued = 0;

function Initialize()
{
	g_SystemServices = GrooveScriptFunctions.CreateNewObject("Groove.SystemServices");
	g_Transport        = GrooveScriptFunctions.CreateNewObject("Groove.TransportPackage");
	g_FileSystem = GrooveScriptFunctions.CreateNewObject( "Groove.Win32FileSystemServices" );

	// Register as an idle handler.
	var pIdleManager = GrooveScriptFunctions.CreateNewObject("Groove.IdleManager");
	var pIdleHandler = ScriptHostComponent.GetScriptDispatch("[IGrooveIdleHandler]");
	g_IdleManagerCookie = pIdleManager.AddHandler( pIdleHandler );
}

function Terminate()
{
	if (g_IdleManagerCookie)
	{
		var pIdleManager = GrooveScriptFunctions.CreateNewObject("Groove.IdleManager");
		pIdleManager.RemoveHandler(g_IdleManagerCookie);
		g_IdleManagerCookie = 0;
	}
}

function DownloadFile( sURL, sDestPath )
{
	var pStreamIn;
	var pStreamOut;
	if( aDownloadDests[ sURL ] )
	{
		Debug( "Already downloading " + sURL );
		return;
	}

	pStreamOut = CreateTemporaryFile( sDestPath );
	if( !pStreamOut )
	{
		Debug( "Couldn't open output file for " + sURL );
		FireEvent( "", "DownloadFailed", sURL, "Unable to open output file " + sDestPath );
		return;
	}

	pStreamIn = GetDownloadStream( sURL );
	if( !pStreamIn )
	{
		pStreamOut.Close();
		DeleteTemporaryFile( sDestPath );
		Debug( "Couldn't open download stream for " + sURL );
		FireEvent( "", "DownloadFailed", sURL, "Unable to open URL" );
		return;
	}

	aDownloadOutStreams[ sURL ] = pStreamOut;
	aDownloadInStreams[ sURL ] = pStreamIn;
	aDownloadDests[ sURL ] = sDestPath;
	nQueued++;

	FireEvent( "", "DownloadQueued", sURL, sDestPath );
}


function CreateTemporaryFile( sDestPath )
{
	var pOut;
	try
	{
		pOut = g_Misc.StreamFactory.CreateByteOutputStreamFromFile( sDestPath, false, false );
	}
	catch( _ex )
	{
		pOut = null;
	}
	return pOut;
}

function DeleteTemporaryFile( sPath )
{
	if( g_FileSystem.DoesFileExist( sPath ) )
		g_FileSystem.DeleteFile( sPath );
}

function GetDownloadStream( sURL )
{
	var nPort = 80;
	var pURI = g_Misc.OpenURI( sURL );
	var sHost = pURI.Host;
	var sPath = "/" + pURI.GetPath(2);
	var sPort = pURI.Port;
	if( sPort != "" ) nPort = parseInt( sPort );

	var h = g_Transport.OpenHTTPClient( sHost, nPort );
	
//	g_RSSClient.SourceConnect( h, -1 );
	h.Connect( -1 );

	var b = g_Misc.EnumFactory.CreateBSTREnum();
	b.BSTREnumCreate.Add( "Host: " + sHost );
	b.BSTREnumCreate.Add( "Accept: */*" );
	b.BSTREnumCreate.Add( "User-Agent: Cabezal NewsClient" );
	b.BSTREnumCreate.Add( "Referer: http://www.cabezal.com/Cabezal/Tools/NewsClient/refer.html" );

//	var x = g_RSSClient.SourceGet( h, sPath, b, 1 );
	var pHTTPResult = h.Get( sPath, b, 1 );
	if( pHTTPResult.Status != 200 )
	{
		Debug( "Error, HTTP status " + pHTTPResult.Status );
		return null;
	}

	var x = pHTTPResult.ResponseBody;
	if( x )
	{
		aDownloadHTTPClients[ sURL ] = h;
	}
	return x;
}

function CloseDownloadStream( sURL )
{
	var pHTTPClient = aDownloadHTTPClients[ sURL ];

//	g_RSSClient.SourceDisconnect( pHTTPClient );
	pHTTPClient.Disconnect();

	aDownloadInStreams[ sURL ] = null;
}

function DownloadChunk( sURL )
{
	var sDestPath = aDownloadDests[ sURL ];
	var pSource = aDownloadInStreams[ sURL ];
	var pDest = aDownloadOutStreams[ sURL ];

	var n = 5000;
	var bFinished = false;
	var bFailed = false;
	try
	{
		while( n > 0 )
		{
			var b = pSource.ReadByte();
			if( b==-1 )
			{
				bFinished = true;
				break;
			}
			pDest.WriteByte( b );
			n--;
		}
	}
	catch( _ex )
	{
		// An error occurred while reading the stream.
		bFailed = true;
	}
	if( !bFailed )
		if( !bFinished )
			return;

	CloseDownloadStream( sURL );
	pDest.Close();

	aDownloadDests[ sURL ] = null;
	aDownloadInStreams[ sURL ] = null;
	aDownloadOutStreams[ sURL ] = null;

	// We're done!
	nQueued--;
	if( bFailed )
		FireEvent( "", "DownloadFailed", sURL, "Unable to complete the download" );
	else
		FireEvent( "", "DownloadComplete", sURL, sDestPath );
}

function Debug( sDebug )
{
//	App.AddNotificationItem( sDebug );
}
				]]>
			</SCRIPT>


			<IMPLEMENTS LIBID="{4253A641-5FA3-11d2-98C2-0080C7E30BA4}" IID="{2ACCD3C1-9C5A-11d3-80CC-00500487878E}">
				<SCRIPT>
					<![CDATA[
/**
  * ---------------------------------------------------
  * IGrooveIdleHandler
  * ---------------------------------------------------
  */
function OnIdle(i_IdleCount)
{
	if( nQueued==0 ) return;

	for( var sURL in aDownloadDests )
	{
		if( aDownloadDests[ sURL ] )
		{
			Debug( "Downloading a chunk from " + sURL );
			DownloadChunk( sURL );
		}
	}
}
					]]>
				</SCRIPT>
			</IMPLEMENTS>

		</g:Component>



		</g:ComponentGroup>

	</g:ToolTemplate>
</g:Document>


